/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|*  * Sparc Disassembler                                                      *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#include "llvm/MC/MCInst.h"
#include "llvm/MC/MCSubtargetInfo.h"
#include "llvm/MC/SubtargetFeature.h"
#include "llvm/Support/DataTypes.h"
#include "llvm/Support/Debug.h"
#include "llvm/Support/LEB128.h"
#include "llvm/Support/raw_ostream.h"
#include <assert.h>

namespace llvm {

// Helper functions for extracting fields from encoded instructions.
// InsnType must either be integral or an APInt-like object that must:
// * be default-constructible and copy-constructible
// * be constructible from an APInt (this can be private)
// * Support insertBits(bits, startBit, numBits)
// * Support extractBitsAsZExtValue(numBits, startBit)
// * Support the ~, &, ==, and != operators with other objects of the same type
// * Support the != and bitwise & with uint64_t
// * Support put (<<) to raw_ostream&
template <typename InsnType>
#if defined(_MSC_VER) && !defined(__clang__)
__declspec(noinline)
#endif
static std::enable_if_t<std::is_integral<InsnType>::value, InsnType>
fieldFromInstruction(const InsnType &insn, unsigned startBit,
                     unsigned numBits) {
  assert(startBit + numBits <= 64 && "Cannot support >64-bit extractions!");
  assert(startBit + numBits <= (sizeof(InsnType) * 8) &&
         "Instruction field out of bounds!");
  InsnType fieldMask;
  if (numBits == sizeof(InsnType) * 8)
    fieldMask = (InsnType)(-1LL);
  else
    fieldMask = (((InsnType)1 << numBits) - 1) << startBit;
  return (insn & fieldMask) >> startBit;
}

template <typename InsnType>
static std::enable_if_t<!std::is_integral<InsnType>::value, uint64_t>
fieldFromInstruction(const InsnType &insn, unsigned startBit,
                     unsigned numBits) {
  return insn.extractBitsAsZExtValue(numBits, startBit);
}

// Helper function for inserting bits extracted from an encoded instruction into
// a field.
template <typename InsnType>
static std::enable_if_t<std::is_integral<InsnType>::value>
insertBits(InsnType &field, InsnType bits, unsigned startBit, unsigned numBits) {
  assert(startBit + numBits <= sizeof field * 8);
  field |= (InsnType)bits << startBit;
}

template <typename InsnType>
static std::enable_if_t<!std::is_integral<InsnType>::value>
insertBits(InsnType &field, uint64_t bits, unsigned startBit, unsigned numBits) {
  field.insertBits(bits, startBit, numBits);
}

static bool Check(DecodeStatus &Out, DecodeStatus In) {
  Out = static_cast<DecodeStatus>(Out & In);
  return Out != MCDisassembler::Fail;
}

static const uint8_t DecoderTableSparc32[] = {
/* 0 */       MCD::OPC_ExtractField, 30, 2,  // Inst{31-30} ...
/* 3 */       MCD::OPC_FilterValue, 0, 187, 2, 0, // Skip to: 707
/* 8 */       MCD::OPC_ExtractField, 22, 3,  // Inst{24-22} ...
/* 11 */      MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 27
/* 16 */      MCD::OPC_CheckField, 25, 5, 0, 32, 30, 0, // Skip to: 7735
/* 23 */      MCD::OPC_Decode, 226, 5, 0, // Opcode: UNIMP
/* 27 */      MCD::OPC_FilterValue, 1, 127, 0, 0, // Skip to: 159
/* 32 */      MCD::OPC_ExtractField, 19, 3,  // Inst{21-19} ...
/* 35 */      MCD::OPC_FilterValue, 0, 31, 0, 0, // Skip to: 71
/* 40 */      MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 43 */      MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 57
/* 48 */      MCD::OPC_CheckPredicate, 0, 2, 30, 0, // Skip to: 7735
/* 53 */      MCD::OPC_Decode, 188, 2, 1, // Opcode: BPICCNT
/* 57 */      MCD::OPC_FilterValue, 1, 249, 29, 0, // Skip to: 7735
/* 62 */      MCD::OPC_CheckPredicate, 0, 244, 29, 0, // Skip to: 7735
/* 67 */      MCD::OPC_Decode, 187, 2, 1, // Opcode: BPICCANT
/* 71 */      MCD::OPC_FilterValue, 1, 31, 0, 0, // Skip to: 107
/* 76 */      MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 79 */      MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 93
/* 84 */      MCD::OPC_CheckPredicate, 0, 222, 29, 0, // Skip to: 7735
/* 89 */      MCD::OPC_Decode, 185, 2, 1, // Opcode: BPICC
/* 93 */      MCD::OPC_FilterValue, 1, 213, 29, 0, // Skip to: 7735
/* 98 */      MCD::OPC_CheckPredicate, 0, 208, 29, 0, // Skip to: 7735
/* 103 */     MCD::OPC_Decode, 186, 2, 1, // Opcode: BPICCA
/* 107 */     MCD::OPC_FilterValue, 4, 21, 0, 0, // Skip to: 133
/* 112 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 115 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 124
/* 120 */     MCD::OPC_Decode, 204, 2, 1, // Opcode: BPXCCNT
/* 124 */     MCD::OPC_FilterValue, 1, 182, 29, 0, // Skip to: 7735
/* 129 */     MCD::OPC_Decode, 203, 2, 1, // Opcode: BPXCCANT
/* 133 */     MCD::OPC_FilterValue, 5, 173, 29, 0, // Skip to: 7735
/* 138 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 141 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 150
/* 146 */     MCD::OPC_Decode, 201, 2, 1, // Opcode: BPXCC
/* 150 */     MCD::OPC_FilterValue, 1, 156, 29, 0, // Skip to: 7735
/* 155 */     MCD::OPC_Decode, 202, 2, 1, // Opcode: BPXCCA
/* 159 */     MCD::OPC_FilterValue, 2, 32, 0, 0, // Skip to: 196
/* 164 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 167 */     MCD::OPC_FilterValue, 0, 15, 0, 0, // Skip to: 187
/* 172 */     MCD::OPC_CheckField, 25, 4, 8, 4, 0, 0, // Skip to: 183
/* 179 */     MCD::OPC_Decode, 167, 2, 0, // Opcode: BA
/* 183 */     MCD::OPC_Decode, 168, 2, 2, // Opcode: BCOND
/* 187 */     MCD::OPC_FilterValue, 1, 119, 29, 0, // Skip to: 7735
/* 192 */     MCD::OPC_Decode, 169, 2, 2, // Opcode: BCONDA
/* 196 */     MCD::OPC_FilterValue, 3, 59, 1, 0, // Skip to: 516
/* 201 */     MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 204 */     MCD::OPC_FilterValue, 1, 21, 0, 0, // Skip to: 230
/* 209 */     MCD::OPC_ExtractField, 19, 1,  // Inst{19} ...
/* 212 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 221
/* 217 */     MCD::OPC_Decode, 207, 2, 3, // Opcode: BPZnapn
/* 221 */     MCD::OPC_FilterValue, 1, 85, 29, 0, // Skip to: 7735
/* 226 */     MCD::OPC_Decode, 208, 2, 3, // Opcode: BPZnapt
/* 230 */     MCD::OPC_FilterValue, 2, 21, 0, 0, // Skip to: 256
/* 235 */     MCD::OPC_ExtractField, 19, 1,  // Inst{19} ...
/* 238 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 247
/* 243 */     MCD::OPC_Decode, 191, 2, 3, // Opcode: BPLEZnapn
/* 247 */     MCD::OPC_FilterValue, 1, 59, 29, 0, // Skip to: 7735
/* 252 */     MCD::OPC_Decode, 192, 2, 3, // Opcode: BPLEZnapt
/* 256 */     MCD::OPC_FilterValue, 3, 21, 0, 0, // Skip to: 282
/* 261 */     MCD::OPC_ExtractField, 19, 1,  // Inst{19} ...
/* 264 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 273
/* 269 */     MCD::OPC_Decode, 195, 2, 3, // Opcode: BPLZnapn
/* 273 */     MCD::OPC_FilterValue, 1, 33, 29, 0, // Skip to: 7735
/* 278 */     MCD::OPC_Decode, 196, 2, 3, // Opcode: BPLZnapt
/* 282 */     MCD::OPC_FilterValue, 5, 21, 0, 0, // Skip to: 308
/* 287 */     MCD::OPC_ExtractField, 19, 1,  // Inst{19} ...
/* 290 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 299
/* 295 */     MCD::OPC_Decode, 199, 2, 3, // Opcode: BPNZnapn
/* 299 */     MCD::OPC_FilterValue, 1, 7, 29, 0, // Skip to: 7735
/* 304 */     MCD::OPC_Decode, 200, 2, 3, // Opcode: BPNZnapt
/* 308 */     MCD::OPC_FilterValue, 6, 21, 0, 0, // Skip to: 334
/* 313 */     MCD::OPC_ExtractField, 19, 1,  // Inst{19} ...
/* 316 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 325
/* 321 */     MCD::OPC_Decode, 183, 2, 3, // Opcode: BPGZnapn
/* 325 */     MCD::OPC_FilterValue, 1, 237, 28, 0, // Skip to: 7735
/* 330 */     MCD::OPC_Decode, 184, 2, 3, // Opcode: BPGZnapt
/* 334 */     MCD::OPC_FilterValue, 7, 21, 0, 0, // Skip to: 360
/* 339 */     MCD::OPC_ExtractField, 19, 1,  // Inst{19} ...
/* 342 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 351
/* 347 */     MCD::OPC_Decode, 179, 2, 3, // Opcode: BPGEZnapn
/* 351 */     MCD::OPC_FilterValue, 1, 211, 28, 0, // Skip to: 7735
/* 356 */     MCD::OPC_Decode, 180, 2, 3, // Opcode: BPGEZnapt
/* 360 */     MCD::OPC_FilterValue, 17, 21, 0, 0, // Skip to: 386
/* 365 */     MCD::OPC_ExtractField, 19, 1,  // Inst{19} ...
/* 368 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 377
/* 373 */     MCD::OPC_Decode, 205, 2, 3, // Opcode: BPZapn
/* 377 */     MCD::OPC_FilterValue, 1, 185, 28, 0, // Skip to: 7735
/* 382 */     MCD::OPC_Decode, 206, 2, 3, // Opcode: BPZapt
/* 386 */     MCD::OPC_FilterValue, 18, 21, 0, 0, // Skip to: 412
/* 391 */     MCD::OPC_ExtractField, 19, 1,  // Inst{19} ...
/* 394 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 403
/* 399 */     MCD::OPC_Decode, 189, 2, 3, // Opcode: BPLEZapn
/* 403 */     MCD::OPC_FilterValue, 1, 159, 28, 0, // Skip to: 7735
/* 408 */     MCD::OPC_Decode, 190, 2, 3, // Opcode: BPLEZapt
/* 412 */     MCD::OPC_FilterValue, 19, 21, 0, 0, // Skip to: 438
/* 417 */     MCD::OPC_ExtractField, 19, 1,  // Inst{19} ...
/* 420 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 429
/* 425 */     MCD::OPC_Decode, 193, 2, 3, // Opcode: BPLZapn
/* 429 */     MCD::OPC_FilterValue, 1, 133, 28, 0, // Skip to: 7735
/* 434 */     MCD::OPC_Decode, 194, 2, 3, // Opcode: BPLZapt
/* 438 */     MCD::OPC_FilterValue, 21, 21, 0, 0, // Skip to: 464
/* 443 */     MCD::OPC_ExtractField, 19, 1,  // Inst{19} ...
/* 446 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 455
/* 451 */     MCD::OPC_Decode, 197, 2, 3, // Opcode: BPNZapn
/* 455 */     MCD::OPC_FilterValue, 1, 107, 28, 0, // Skip to: 7735
/* 460 */     MCD::OPC_Decode, 198, 2, 3, // Opcode: BPNZapt
/* 464 */     MCD::OPC_FilterValue, 22, 21, 0, 0, // Skip to: 490
/* 469 */     MCD::OPC_ExtractField, 19, 1,  // Inst{19} ...
/* 472 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 481
/* 477 */     MCD::OPC_Decode, 181, 2, 3, // Opcode: BPGZapn
/* 481 */     MCD::OPC_FilterValue, 1, 81, 28, 0, // Skip to: 7735
/* 486 */     MCD::OPC_Decode, 182, 2, 3, // Opcode: BPGZapt
/* 490 */     MCD::OPC_FilterValue, 23, 72, 28, 0, // Skip to: 7735
/* 495 */     MCD::OPC_ExtractField, 19, 1,  // Inst{19} ...
/* 498 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 507
/* 503 */     MCD::OPC_Decode, 177, 2, 3, // Opcode: BPGEZapn
/* 507 */     MCD::OPC_FilterValue, 1, 55, 28, 0, // Skip to: 7735
/* 512 */     MCD::OPC_Decode, 178, 2, 3, // Opcode: BPGEZapt
/* 516 */     MCD::OPC_FilterValue, 4, 22, 0, 0, // Skip to: 543
/* 521 */     MCD::OPC_CheckField, 25, 5, 0, 11, 0, 0, // Skip to: 539
/* 528 */     MCD::OPC_CheckField, 0, 22, 0, 4, 0, 0, // Skip to: 539
/* 535 */     MCD::OPC_Decode, 204, 4, 4, // Opcode: NOP
/* 539 */     MCD::OPC_Decode, 244, 4, 5, // Opcode: SETHIi
/* 543 */     MCD::OPC_FilterValue, 5, 107, 0, 0, // Skip to: 655
/* 548 */     MCD::OPC_ExtractField, 19, 1,  // Inst{19} ...
/* 551 */     MCD::OPC_FilterValue, 0, 31, 0, 0, // Skip to: 587
/* 556 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 559 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 573
/* 564 */     MCD::OPC_CheckPredicate, 0, 254, 27, 0, // Skip to: 7735
/* 569 */     MCD::OPC_Decode, 176, 2, 6, // Opcode: BPFCCNT
/* 573 */     MCD::OPC_FilterValue, 1, 245, 27, 0, // Skip to: 7735
/* 578 */     MCD::OPC_CheckPredicate, 0, 240, 27, 0, // Skip to: 7735
/* 583 */     MCD::OPC_Decode, 175, 2, 6, // Opcode: BPFCCANT
/* 587 */     MCD::OPC_FilterValue, 1, 231, 27, 0, // Skip to: 7735
/* 592 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 595 */     MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 625
/* 600 */     MCD::OPC_CheckPredicate, 0, 11, 0, 0, // Skip to: 616
/* 605 */     MCD::OPC_CheckField, 20, 2, 0, 4, 0, 0, // Skip to: 616
/* 612 */     MCD::OPC_Decode, 252, 2, 1, // Opcode: FBCOND_V9
/* 616 */     MCD::OPC_CheckPredicate, 0, 202, 27, 0, // Skip to: 7735
/* 621 */     MCD::OPC_Decode, 173, 2, 6, // Opcode: BPFCC
/* 625 */     MCD::OPC_FilterValue, 1, 193, 27, 0, // Skip to: 7735
/* 630 */     MCD::OPC_CheckPredicate, 0, 11, 0, 0, // Skip to: 646
/* 635 */     MCD::OPC_CheckField, 20, 2, 0, 4, 0, 0, // Skip to: 646
/* 642 */     MCD::OPC_Decode, 251, 2, 1, // Opcode: FBCONDA_V9
/* 646 */     MCD::OPC_CheckPredicate, 0, 172, 27, 0, // Skip to: 7735
/* 651 */     MCD::OPC_Decode, 174, 2, 6, // Opcode: BPFCCA
/* 655 */     MCD::OPC_FilterValue, 6, 21, 0, 0, // Skip to: 681
/* 660 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 663 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 672
/* 668 */     MCD::OPC_Decode, 249, 2, 2, // Opcode: FBCOND
/* 672 */     MCD::OPC_FilterValue, 1, 146, 27, 0, // Skip to: 7735
/* 677 */     MCD::OPC_Decode, 250, 2, 2, // Opcode: FBCONDA
/* 681 */     MCD::OPC_FilterValue, 7, 137, 27, 0, // Skip to: 7735
/* 686 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 689 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 698
/* 694 */     MCD::OPC_Decode, 217, 2, 2, // Opcode: CBCOND
/* 698 */     MCD::OPC_FilterValue, 1, 120, 27, 0, // Skip to: 7735
/* 703 */     MCD::OPC_Decode, 218, 2, 2, // Opcode: CBCONDA
/* 707 */     MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 716
/* 712 */     MCD::OPC_Decode, 210, 2, 7, // Opcode: CALL
/* 716 */     MCD::OPC_FilterValue, 2, 91, 21, 0, // Skip to: 6188
/* 721 */     MCD::OPC_ExtractField, 19, 6,  // Inst{24-19} ...
/* 724 */     MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 757
/* 729 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 732 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 748
/* 737 */     MCD::OPC_CheckField, 5, 8, 0, 79, 27, 0, // Skip to: 7735
/* 744 */     MCD::OPC_Decode, 150, 2, 8, // Opcode: ADDrr
/* 748 */     MCD::OPC_FilterValue, 1, 70, 27, 0, // Skip to: 7735
/* 753 */     MCD::OPC_Decode, 149, 2, 9, // Opcode: ADDri
/* 757 */     MCD::OPC_FilterValue, 1, 28, 0, 0, // Skip to: 790
/* 762 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 765 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 781
/* 770 */     MCD::OPC_CheckField, 5, 8, 0, 46, 27, 0, // Skip to: 7735
/* 777 */     MCD::OPC_Decode, 163, 2, 8, // Opcode: ANDrr
/* 781 */     MCD::OPC_FilterValue, 1, 37, 27, 0, // Skip to: 7735
/* 786 */     MCD::OPC_Decode, 162, 2, 9, // Opcode: ANDri
/* 790 */     MCD::OPC_FilterValue, 2, 28, 0, 0, // Skip to: 823
/* 795 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 798 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 814
/* 803 */     MCD::OPC_CheckField, 5, 8, 0, 13, 27, 0, // Skip to: 7735
/* 810 */     MCD::OPC_Decode, 215, 4, 8, // Opcode: ORrr
/* 814 */     MCD::OPC_FilterValue, 1, 4, 27, 0, // Skip to: 7735
/* 819 */     MCD::OPC_Decode, 214, 4, 9, // Opcode: ORri
/* 823 */     MCD::OPC_FilterValue, 3, 28, 0, 0, // Skip to: 856
/* 828 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 831 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 847
/* 836 */     MCD::OPC_CheckField, 5, 8, 0, 236, 26, 0, // Skip to: 7735
/* 843 */     MCD::OPC_Decode, 132, 6, 8, // Opcode: XORrr
/* 847 */     MCD::OPC_FilterValue, 1, 227, 26, 0, // Skip to: 7735
/* 852 */     MCD::OPC_Decode, 131, 6, 9, // Opcode: XORri
/* 856 */     MCD::OPC_FilterValue, 4, 28, 0, 0, // Skip to: 889
/* 861 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 864 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 880
/* 869 */     MCD::OPC_CheckField, 5, 8, 0, 203, 26, 0, // Skip to: 7735
/* 876 */     MCD::OPC_Decode, 185, 5, 8, // Opcode: SUBrr
/* 880 */     MCD::OPC_FilterValue, 1, 194, 26, 0, // Skip to: 7735
/* 885 */     MCD::OPC_Decode, 184, 5, 9, // Opcode: SUBri
/* 889 */     MCD::OPC_FilterValue, 5, 28, 0, 0, // Skip to: 922
/* 894 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 897 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 913
/* 902 */     MCD::OPC_CheckField, 5, 8, 0, 170, 26, 0, // Skip to: 7735
/* 909 */     MCD::OPC_Decode, 158, 2, 8, // Opcode: ANDNrr
/* 913 */     MCD::OPC_FilterValue, 1, 161, 26, 0, // Skip to: 7735
/* 918 */     MCD::OPC_Decode, 157, 2, 9, // Opcode: ANDNri
/* 922 */     MCD::OPC_FilterValue, 6, 28, 0, 0, // Skip to: 955
/* 927 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 930 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 946
/* 935 */     MCD::OPC_CheckField, 5, 8, 0, 137, 26, 0, // Skip to: 7735
/* 942 */     MCD::OPC_Decode, 210, 4, 8, // Opcode: ORNrr
/* 946 */     MCD::OPC_FilterValue, 1, 128, 26, 0, // Skip to: 7735
/* 951 */     MCD::OPC_Decode, 209, 4, 9, // Opcode: ORNri
/* 955 */     MCD::OPC_FilterValue, 7, 28, 0, 0, // Skip to: 988
/* 960 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 963 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 979
/* 968 */     MCD::OPC_CheckField, 5, 8, 0, 104, 26, 0, // Skip to: 7735
/* 975 */     MCD::OPC_Decode, 254, 5, 8, // Opcode: XNORrr
/* 979 */     MCD::OPC_FilterValue, 1, 95, 26, 0, // Skip to: 7735
/* 984 */     MCD::OPC_Decode, 253, 5, 9, // Opcode: XNORri
/* 988 */     MCD::OPC_FilterValue, 8, 28, 0, 0, // Skip to: 1021
/* 993 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 996 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1012
/* 1001 */    MCD::OPC_CheckField, 5, 8, 0, 71, 26, 0, // Skip to: 7735
/* 1008 */    MCD::OPC_Decode, 142, 2, 8, // Opcode: ADDCrr
/* 1012 */    MCD::OPC_FilterValue, 1, 62, 26, 0, // Skip to: 7735
/* 1017 */    MCD::OPC_Decode, 141, 2, 9, // Opcode: ADDCri
/* 1021 */    MCD::OPC_FilterValue, 9, 28, 0, 0, // Skip to: 1054
/* 1026 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1029 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1045
/* 1034 */    MCD::OPC_CheckField, 5, 8, 0, 38, 26, 0, // Skip to: 7735
/* 1041 */    MCD::OPC_Decode, 203, 4, 10, // Opcode: MULXrr
/* 1045 */    MCD::OPC_FilterValue, 1, 29, 26, 0, // Skip to: 7735
/* 1050 */    MCD::OPC_Decode, 202, 4, 11, // Opcode: MULXri
/* 1054 */    MCD::OPC_FilterValue, 10, 28, 0, 0, // Skip to: 1087
/* 1059 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1062 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1078
/* 1067 */    MCD::OPC_CheckField, 5, 8, 0, 5, 26, 0, // Skip to: 7735
/* 1074 */    MCD::OPC_Decode, 225, 5, 8, // Opcode: UMULrr
/* 1078 */    MCD::OPC_FilterValue, 1, 252, 25, 0, // Skip to: 7735
/* 1083 */    MCD::OPC_Decode, 224, 5, 9, // Opcode: UMULri
/* 1087 */    MCD::OPC_FilterValue, 11, 28, 0, 0, // Skip to: 1120
/* 1092 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1095 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1111
/* 1100 */    MCD::OPC_CheckField, 5, 8, 0, 228, 25, 0, // Skip to: 7735
/* 1107 */    MCD::OPC_Decode, 129, 5, 8, // Opcode: SMULrr
/* 1111 */    MCD::OPC_FilterValue, 1, 219, 25, 0, // Skip to: 7735
/* 1116 */    MCD::OPC_Decode, 128, 5, 9, // Opcode: SMULri
/* 1120 */    MCD::OPC_FilterValue, 12, 28, 0, 0, // Skip to: 1153
/* 1125 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1128 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1144
/* 1133 */    MCD::OPC_CheckField, 5, 8, 0, 195, 25, 0, // Skip to: 7735
/* 1140 */    MCD::OPC_Decode, 179, 5, 8, // Opcode: SUBCrr
/* 1144 */    MCD::OPC_FilterValue, 1, 186, 25, 0, // Skip to: 7735
/* 1149 */    MCD::OPC_Decode, 178, 5, 9, // Opcode: SUBCri
/* 1153 */    MCD::OPC_FilterValue, 13, 28, 0, 0, // Skip to: 1186
/* 1158 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1161 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1177
/* 1166 */    MCD::OPC_CheckField, 5, 8, 0, 162, 25, 0, // Skip to: 7735
/* 1173 */    MCD::OPC_Decode, 216, 5, 10, // Opcode: UDIVXrr
/* 1177 */    MCD::OPC_FilterValue, 1, 153, 25, 0, // Skip to: 7735
/* 1182 */    MCD::OPC_Decode, 215, 5, 11, // Opcode: UDIVXri
/* 1186 */    MCD::OPC_FilterValue, 14, 28, 0, 0, // Skip to: 1219
/* 1191 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1194 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1210
/* 1199 */    MCD::OPC_CheckField, 5, 8, 0, 129, 25, 0, // Skip to: 7735
/* 1206 */    MCD::OPC_Decode, 218, 5, 8, // Opcode: UDIVrr
/* 1210 */    MCD::OPC_FilterValue, 1, 120, 25, 0, // Skip to: 7735
/* 1215 */    MCD::OPC_Decode, 217, 5, 9, // Opcode: UDIVri
/* 1219 */    MCD::OPC_FilterValue, 15, 28, 0, 0, // Skip to: 1252
/* 1224 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1227 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1243
/* 1232 */    MCD::OPC_CheckField, 5, 8, 0, 96, 25, 0, // Skip to: 7735
/* 1239 */    MCD::OPC_Decode, 242, 4, 8, // Opcode: SDIVrr
/* 1243 */    MCD::OPC_FilterValue, 1, 87, 25, 0, // Skip to: 7735
/* 1248 */    MCD::OPC_Decode, 241, 4, 9, // Opcode: SDIVri
/* 1252 */    MCD::OPC_FilterValue, 16, 28, 0, 0, // Skip to: 1285
/* 1257 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1260 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1276
/* 1265 */    MCD::OPC_CheckField, 5, 8, 0, 63, 25, 0, // Skip to: 7735
/* 1272 */    MCD::OPC_Decode, 140, 2, 8, // Opcode: ADDCCrr
/* 1276 */    MCD::OPC_FilterValue, 1, 54, 25, 0, // Skip to: 7735
/* 1281 */    MCD::OPC_Decode, 139, 2, 9, // Opcode: ADDCCri
/* 1285 */    MCD::OPC_FilterValue, 17, 28, 0, 0, // Skip to: 1318
/* 1290 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1293 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1309
/* 1298 */    MCD::OPC_CheckField, 5, 8, 0, 30, 25, 0, // Skip to: 7735
/* 1305 */    MCD::OPC_Decode, 154, 2, 8, // Opcode: ANDCCrr
/* 1309 */    MCD::OPC_FilterValue, 1, 21, 25, 0, // Skip to: 7735
/* 1314 */    MCD::OPC_Decode, 153, 2, 9, // Opcode: ANDCCri
/* 1318 */    MCD::OPC_FilterValue, 18, 28, 0, 0, // Skip to: 1351
/* 1323 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1326 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1342
/* 1331 */    MCD::OPC_CheckField, 5, 8, 0, 253, 24, 0, // Skip to: 7735
/* 1338 */    MCD::OPC_Decode, 206, 4, 8, // Opcode: ORCCrr
/* 1342 */    MCD::OPC_FilterValue, 1, 244, 24, 0, // Skip to: 7735
/* 1347 */    MCD::OPC_Decode, 205, 4, 9, // Opcode: ORCCri
/* 1351 */    MCD::OPC_FilterValue, 19, 28, 0, 0, // Skip to: 1384
/* 1356 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1359 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1375
/* 1364 */    MCD::OPC_CheckField, 5, 8, 0, 220, 24, 0, // Skip to: 7735
/* 1371 */    MCD::OPC_Decode, 128, 6, 8, // Opcode: XORCCrr
/* 1375 */    MCD::OPC_FilterValue, 1, 211, 24, 0, // Skip to: 7735
/* 1380 */    MCD::OPC_Decode, 255, 5, 9, // Opcode: XORCCri
/* 1384 */    MCD::OPC_FilterValue, 20, 51, 0, 0, // Skip to: 1440
/* 1389 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1392 */    MCD::OPC_FilterValue, 0, 23, 0, 0, // Skip to: 1420
/* 1397 */    MCD::OPC_ExtractField, 5, 8,  // Inst{12-5} ...
/* 1400 */    MCD::OPC_FilterValue, 0, 186, 24, 0, // Skip to: 7735
/* 1405 */    MCD::OPC_CheckField, 25, 5, 0, 4, 0, 0, // Skip to: 1416
/* 1412 */    MCD::OPC_Decode, 223, 2, 12, // Opcode: CMPrr
/* 1416 */    MCD::OPC_Decode, 177, 5, 8, // Opcode: SUBCCrr
/* 1420 */    MCD::OPC_FilterValue, 1, 166, 24, 0, // Skip to: 7735
/* 1425 */    MCD::OPC_CheckField, 25, 5, 0, 4, 0, 0, // Skip to: 1436
/* 1432 */    MCD::OPC_Decode, 222, 2, 13, // Opcode: CMPri
/* 1436 */    MCD::OPC_Decode, 176, 5, 9, // Opcode: SUBCCri
/* 1440 */    MCD::OPC_FilterValue, 21, 28, 0, 0, // Skip to: 1473
/* 1445 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1448 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1464
/* 1453 */    MCD::OPC_CheckField, 5, 8, 0, 131, 24, 0, // Skip to: 7735
/* 1460 */    MCD::OPC_Decode, 156, 2, 8, // Opcode: ANDNCCrr
/* 1464 */    MCD::OPC_FilterValue, 1, 122, 24, 0, // Skip to: 7735
/* 1469 */    MCD::OPC_Decode, 155, 2, 9, // Opcode: ANDNCCri
/* 1473 */    MCD::OPC_FilterValue, 22, 28, 0, 0, // Skip to: 1506
/* 1478 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1481 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1497
/* 1486 */    MCD::OPC_CheckField, 5, 8, 0, 98, 24, 0, // Skip to: 7735
/* 1493 */    MCD::OPC_Decode, 208, 4, 8, // Opcode: ORNCCrr
/* 1497 */    MCD::OPC_FilterValue, 1, 89, 24, 0, // Skip to: 7735
/* 1502 */    MCD::OPC_Decode, 207, 4, 9, // Opcode: ORNCCri
/* 1506 */    MCD::OPC_FilterValue, 23, 28, 0, 0, // Skip to: 1539
/* 1511 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1514 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1530
/* 1519 */    MCD::OPC_CheckField, 5, 8, 0, 65, 24, 0, // Skip to: 7735
/* 1526 */    MCD::OPC_Decode, 251, 5, 8, // Opcode: XNORCCrr
/* 1530 */    MCD::OPC_FilterValue, 1, 56, 24, 0, // Skip to: 7735
/* 1535 */    MCD::OPC_Decode, 250, 5, 9, // Opcode: XNORCCri
/* 1539 */    MCD::OPC_FilterValue, 24, 28, 0, 0, // Skip to: 1572
/* 1544 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1547 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1563
/* 1552 */    MCD::OPC_CheckField, 5, 8, 0, 32, 24, 0, // Skip to: 7735
/* 1559 */    MCD::OPC_Decode, 144, 2, 8, // Opcode: ADDErr
/* 1563 */    MCD::OPC_FilterValue, 1, 23, 24, 0, // Skip to: 7735
/* 1568 */    MCD::OPC_Decode, 143, 2, 9, // Opcode: ADDEri
/* 1572 */    MCD::OPC_FilterValue, 26, 28, 0, 0, // Skip to: 1605
/* 1577 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1580 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1596
/* 1585 */    MCD::OPC_CheckField, 5, 8, 0, 255, 23, 0, // Skip to: 7735
/* 1592 */    MCD::OPC_Decode, 222, 5, 8, // Opcode: UMULCCrr
/* 1596 */    MCD::OPC_FilterValue, 1, 246, 23, 0, // Skip to: 7735
/* 1601 */    MCD::OPC_Decode, 221, 5, 9, // Opcode: UMULCCri
/* 1605 */    MCD::OPC_FilterValue, 27, 28, 0, 0, // Skip to: 1638
/* 1610 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1613 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1629
/* 1618 */    MCD::OPC_CheckField, 5, 8, 0, 222, 23, 0, // Skip to: 7735
/* 1625 */    MCD::OPC_Decode, 255, 4, 8, // Opcode: SMULCCrr
/* 1629 */    MCD::OPC_FilterValue, 1, 213, 23, 0, // Skip to: 7735
/* 1634 */    MCD::OPC_Decode, 254, 4, 9, // Opcode: SMULCCri
/* 1638 */    MCD::OPC_FilterValue, 28, 28, 0, 0, // Skip to: 1671
/* 1643 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1646 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1662
/* 1651 */    MCD::OPC_CheckField, 5, 8, 0, 189, 23, 0, // Skip to: 7735
/* 1658 */    MCD::OPC_Decode, 181, 5, 8, // Opcode: SUBErr
/* 1662 */    MCD::OPC_FilterValue, 1, 180, 23, 0, // Skip to: 7735
/* 1667 */    MCD::OPC_Decode, 180, 5, 9, // Opcode: SUBEri
/* 1671 */    MCD::OPC_FilterValue, 30, 28, 0, 0, // Skip to: 1704
/* 1676 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1679 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1695
/* 1684 */    MCD::OPC_CheckField, 5, 8, 0, 156, 23, 0, // Skip to: 7735
/* 1691 */    MCD::OPC_Decode, 214, 5, 8, // Opcode: UDIVCCrr
/* 1695 */    MCD::OPC_FilterValue, 1, 147, 23, 0, // Skip to: 7735
/* 1700 */    MCD::OPC_Decode, 213, 5, 9, // Opcode: UDIVCCri
/* 1704 */    MCD::OPC_FilterValue, 31, 28, 0, 0, // Skip to: 1737
/* 1709 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1712 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1728
/* 1717 */    MCD::OPC_CheckField, 5, 8, 0, 123, 23, 0, // Skip to: 7735
/* 1724 */    MCD::OPC_Decode, 238, 4, 8, // Opcode: SDIVCCrr
/* 1728 */    MCD::OPC_FilterValue, 1, 114, 23, 0, // Skip to: 7735
/* 1733 */    MCD::OPC_Decode, 237, 4, 9, // Opcode: SDIVCCri
/* 1737 */    MCD::OPC_FilterValue, 32, 28, 0, 0, // Skip to: 1770
/* 1742 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1745 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1761
/* 1750 */    MCD::OPC_CheckField, 5, 8, 0, 90, 23, 0, // Skip to: 7735
/* 1757 */    MCD::OPC_Decode, 195, 5, 8, // Opcode: TADDCCrr
/* 1761 */    MCD::OPC_FilterValue, 1, 81, 23, 0, // Skip to: 7735
/* 1766 */    MCD::OPC_Decode, 194, 5, 9, // Opcode: TADDCCri
/* 1770 */    MCD::OPC_FilterValue, 33, 28, 0, 0, // Skip to: 1803
/* 1775 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1778 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1794
/* 1783 */    MCD::OPC_CheckField, 5, 8, 0, 57, 23, 0, // Skip to: 7735
/* 1790 */    MCD::OPC_Decode, 210, 5, 8, // Opcode: TSUBCCrr
/* 1794 */    MCD::OPC_FilterValue, 1, 48, 23, 0, // Skip to: 7735
/* 1799 */    MCD::OPC_Decode, 209, 5, 9, // Opcode: TSUBCCri
/* 1803 */    MCD::OPC_FilterValue, 34, 28, 0, 0, // Skip to: 1836
/* 1808 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1811 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1827
/* 1816 */    MCD::OPC_CheckField, 5, 8, 0, 24, 23, 0, // Skip to: 7735
/* 1823 */    MCD::OPC_Decode, 193, 5, 8, // Opcode: TADDCCTVrr
/* 1827 */    MCD::OPC_FilterValue, 1, 15, 23, 0, // Skip to: 7735
/* 1832 */    MCD::OPC_Decode, 192, 5, 9, // Opcode: TADDCCTVri
/* 1836 */    MCD::OPC_FilterValue, 35, 28, 0, 0, // Skip to: 1869
/* 1841 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1844 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1860
/* 1849 */    MCD::OPC_CheckField, 5, 8, 0, 247, 22, 0, // Skip to: 7735
/* 1856 */    MCD::OPC_Decode, 208, 5, 8, // Opcode: TSUBCCTVrr
/* 1860 */    MCD::OPC_FilterValue, 1, 238, 22, 0, // Skip to: 7735
/* 1865 */    MCD::OPC_Decode, 207, 5, 9, // Opcode: TSUBCCTVri
/* 1869 */    MCD::OPC_FilterValue, 36, 28, 0, 0, // Skip to: 1902
/* 1874 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1877 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1893
/* 1882 */    MCD::OPC_CheckField, 5, 8, 0, 214, 22, 0, // Skip to: 7735
/* 1889 */    MCD::OPC_Decode, 201, 4, 8, // Opcode: MULSCCrr
/* 1893 */    MCD::OPC_FilterValue, 1, 205, 22, 0, // Skip to: 7735
/* 1898 */    MCD::OPC_Decode, 200, 4, 9, // Opcode: MULSCCri
/* 1902 */    MCD::OPC_FilterValue, 37, 39, 0, 0, // Skip to: 1946
/* 1907 */    MCD::OPC_ExtractField, 12, 2,  // Inst{13-12} ...
/* 1910 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 1919
/* 1915 */    MCD::OPC_Decode, 251, 4, 8, // Opcode: SLLrr
/* 1919 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1928
/* 1924 */    MCD::OPC_Decode, 249, 4, 14, // Opcode: SLLXrr
/* 1928 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1937
/* 1933 */    MCD::OPC_Decode, 250, 4, 15, // Opcode: SLLri
/* 1937 */    MCD::OPC_FilterValue, 3, 161, 22, 0, // Skip to: 7735
/* 1942 */    MCD::OPC_Decode, 248, 4, 16, // Opcode: SLLXri
/* 1946 */    MCD::OPC_FilterValue, 38, 39, 0, 0, // Skip to: 1990
/* 1951 */    MCD::OPC_ExtractField, 12, 2,  // Inst{13-12} ...
/* 1954 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 1963
/* 1959 */    MCD::OPC_Decode, 137, 5, 8, // Opcode: SRLrr
/* 1963 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1972
/* 1968 */    MCD::OPC_Decode, 135, 5, 14, // Opcode: SRLXrr
/* 1972 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1981
/* 1977 */    MCD::OPC_Decode, 136, 5, 15, // Opcode: SRLri
/* 1981 */    MCD::OPC_FilterValue, 3, 117, 22, 0, // Skip to: 7735
/* 1986 */    MCD::OPC_Decode, 134, 5, 16, // Opcode: SRLXri
/* 1990 */    MCD::OPC_FilterValue, 39, 39, 0, 0, // Skip to: 2034
/* 1995 */    MCD::OPC_ExtractField, 12, 2,  // Inst{13-12} ...
/* 1998 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2007
/* 2003 */    MCD::OPC_Decode, 133, 5, 8, // Opcode: SRArr
/* 2007 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2016
/* 2012 */    MCD::OPC_Decode, 131, 5, 14, // Opcode: SRAXrr
/* 2016 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2025
/* 2021 */    MCD::OPC_Decode, 132, 5, 15, // Opcode: SRAri
/* 2025 */    MCD::OPC_FilterValue, 3, 73, 22, 0, // Skip to: 7735
/* 2030 */    MCD::OPC_Decode, 130, 5, 16, // Opcode: SRAXri
/* 2034 */    MCD::OPC_FilterValue, 40, 81, 0, 0, // Skip to: 2120
/* 2039 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 2042 */    MCD::OPC_FilterValue, 0, 45, 0, 0, // Skip to: 2092
/* 2047 */    MCD::OPC_ExtractField, 0, 13,  // Inst{12-0} ...
/* 2050 */    MCD::OPC_FilterValue, 0, 48, 22, 0, // Skip to: 7735
/* 2055 */    MCD::OPC_ExtractField, 14, 5,  // Inst{18-14} ...
/* 2058 */    MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 2072
/* 2063 */    MCD::OPC_CheckPredicate, 0, 20, 0, 0, // Skip to: 2088
/* 2068 */    MCD::OPC_Decode, 224, 4, 17, // Opcode: RDPC
/* 2072 */    MCD::OPC_FilterValue, 15, 11, 0, 0, // Skip to: 2088
/* 2077 */    MCD::OPC_CheckField, 25, 5, 0, 4, 0, 0, // Skip to: 2088
/* 2084 */    MCD::OPC_Decode, 139, 5, 4, // Opcode: STBAR
/* 2088 */    MCD::OPC_Decode, 223, 4, 18, // Opcode: RDASR
/* 2092 */    MCD::OPC_FilterValue, 1, 6, 22, 0, // Skip to: 7735
/* 2097 */    MCD::OPC_CheckPredicate, 0, 1, 22, 0, // Skip to: 7735
/* 2102 */    MCD::OPC_CheckField, 25, 5, 0, 250, 21, 0, // Skip to: 7735
/* 2109 */    MCD::OPC_CheckField, 14, 5, 15, 243, 21, 0, // Skip to: 7735
/* 2116 */    MCD::OPC_Decode, 186, 4, 19, // Opcode: MEMBARi
/* 2120 */    MCD::OPC_FilterValue, 41, 11, 0, 0, // Skip to: 2136
/* 2125 */    MCD::OPC_CheckField, 0, 19, 0, 227, 21, 0, // Skip to: 7735
/* 2132 */    MCD::OPC_Decode, 226, 4, 17, // Opcode: RDPSR
/* 2136 */    MCD::OPC_FilterValue, 42, 28, 0, 0, // Skip to: 2169
/* 2141 */    MCD::OPC_ExtractField, 0, 14,  // Inst{13-0} ...
/* 2144 */    MCD::OPC_FilterValue, 0, 210, 21, 0, // Skip to: 7735
/* 2149 */    MCD::OPC_CheckField, 14, 5, 0, 4, 0, 0, // Skip to: 2160
/* 2156 */    MCD::OPC_Decode, 228, 4, 17, // Opcode: RDWIM
/* 2160 */    MCD::OPC_CheckPredicate, 0, 194, 21, 0, // Skip to: 7735
/* 2165 */    MCD::OPC_Decode, 225, 4, 20, // Opcode: RDPR
/* 2169 */    MCD::OPC_FilterValue, 43, 28, 0, 0, // Skip to: 2202
/* 2174 */    MCD::OPC_ExtractField, 0, 19,  // Inst{18-0} ...
/* 2177 */    MCD::OPC_FilterValue, 0, 177, 21, 0, // Skip to: 7735
/* 2182 */    MCD::OPC_CheckPredicate, 0, 11, 0, 0, // Skip to: 2198
/* 2187 */    MCD::OPC_CheckField, 25, 5, 0, 4, 0, 0, // Skip to: 2198
/* 2194 */    MCD::OPC_Decode, 159, 3, 4, // Opcode: FLUSHW
/* 2198 */    MCD::OPC_Decode, 227, 4, 17, // Opcode: RDTBR
/* 2202 */    MCD::OPC_FilterValue, 44, 141, 0, 0, // Skip to: 2348
/* 2207 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 2210 */    MCD::OPC_FilterValue, 0, 64, 0, 0, // Skip to: 2279
/* 2215 */    MCD::OPC_ExtractField, 18, 1,  // Inst{18} ...
/* 2218 */    MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 2248
/* 2223 */    MCD::OPC_CheckPredicate, 0, 11, 0, 0, // Skip to: 2239
/* 2228 */    MCD::OPC_CheckField, 11, 2, 0, 4, 0, 0, // Skip to: 2239
/* 2235 */    MCD::OPC_Decode, 189, 4, 21, // Opcode: MOVFCCrr
/* 2239 */    MCD::OPC_CheckPredicate, 0, 115, 21, 0, // Skip to: 7735
/* 2244 */    MCD::OPC_Decode, 237, 5, 22, // Opcode: V9MOVFCCrr
/* 2248 */    MCD::OPC_FilterValue, 1, 106, 21, 0, // Skip to: 7735
/* 2253 */    MCD::OPC_ExtractField, 11, 2,  // Inst{12-11} ...
/* 2256 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 2270
/* 2261 */    MCD::OPC_CheckPredicate, 0, 93, 21, 0, // Skip to: 7735
/* 2266 */    MCD::OPC_Decode, 191, 4, 21, // Opcode: MOVICCrr
/* 2270 */    MCD::OPC_FilterValue, 2, 84, 21, 0, // Skip to: 7735
/* 2275 */    MCD::OPC_Decode, 198, 4, 21, // Opcode: MOVXCCrr
/* 2279 */    MCD::OPC_FilterValue, 1, 75, 21, 0, // Skip to: 7735
/* 2284 */    MCD::OPC_ExtractField, 18, 1,  // Inst{18} ...
/* 2287 */    MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 2317
/* 2292 */    MCD::OPC_CheckPredicate, 0, 11, 0, 0, // Skip to: 2308
/* 2297 */    MCD::OPC_CheckField, 11, 2, 0, 4, 0, 0, // Skip to: 2308
/* 2304 */    MCD::OPC_Decode, 188, 4, 23, // Opcode: MOVFCCri
/* 2308 */    MCD::OPC_CheckPredicate, 0, 46, 21, 0, // Skip to: 7735
/* 2313 */    MCD::OPC_Decode, 236, 5, 24, // Opcode: V9MOVFCCri
/* 2317 */    MCD::OPC_FilterValue, 1, 37, 21, 0, // Skip to: 7735
/* 2322 */    MCD::OPC_ExtractField, 11, 2,  // Inst{12-11} ...
/* 2325 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 2339
/* 2330 */    MCD::OPC_CheckPredicate, 0, 24, 21, 0, // Skip to: 7735
/* 2335 */    MCD::OPC_Decode, 190, 4, 23, // Opcode: MOVICCri
/* 2339 */    MCD::OPC_FilterValue, 2, 15, 21, 0, // Skip to: 7735
/* 2344 */    MCD::OPC_Decode, 197, 4, 23, // Opcode: MOVXCCri
/* 2348 */    MCD::OPC_FilterValue, 45, 28, 0, 0, // Skip to: 2381
/* 2353 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 2356 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 2372
/* 2361 */    MCD::OPC_CheckField, 5, 8, 0, 247, 20, 0, // Skip to: 7735
/* 2368 */    MCD::OPC_Decode, 240, 4, 10, // Opcode: SDIVXrr
/* 2372 */    MCD::OPC_FilterValue, 1, 238, 20, 0, // Skip to: 7735
/* 2377 */    MCD::OPC_Decode, 239, 4, 11, // Opcode: SDIVXri
/* 2381 */    MCD::OPC_FilterValue, 46, 16, 0, 0, // Skip to: 2402
/* 2386 */    MCD::OPC_CheckPredicate, 0, 224, 20, 0, // Skip to: 7735
/* 2391 */    MCD::OPC_CheckField, 5, 14, 0, 217, 20, 0, // Skip to: 7735
/* 2398 */    MCD::OPC_Decode, 218, 4, 25, // Opcode: POPCrr
/* 2402 */    MCD::OPC_FilterValue, 47, 28, 0, 0, // Skip to: 2435
/* 2407 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 2410 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 2426
/* 2415 */    MCD::OPC_CheckField, 5, 5, 0, 193, 20, 0, // Skip to: 7735
/* 2422 */    MCD::OPC_Decode, 193, 4, 26, // Opcode: MOVRrr
/* 2426 */    MCD::OPC_FilterValue, 1, 184, 20, 0, // Skip to: 7735
/* 2431 */    MCD::OPC_Decode, 192, 4, 27, // Opcode: MOVRri
/* 2435 */    MCD::OPC_FilterValue, 48, 51, 0, 0, // Skip to: 2491
/* 2440 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 2443 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 2459
/* 2448 */    MCD::OPC_CheckField, 5, 8, 0, 160, 20, 0, // Skip to: 7735
/* 2455 */    MCD::OPC_Decode, 239, 5, 28, // Opcode: WRASRrr
/* 2459 */    MCD::OPC_FilterValue, 1, 151, 20, 0, // Skip to: 7735
/* 2464 */    MCD::OPC_CheckPredicate, 0, 18, 0, 0, // Skip to: 2487
/* 2469 */    MCD::OPC_CheckField, 25, 5, 15, 11, 0, 0, // Skip to: 2487
/* 2476 */    MCD::OPC_CheckField, 14, 5, 0, 4, 0, 0, // Skip to: 2487
/* 2483 */    MCD::OPC_Decode, 247, 4, 29, // Opcode: SIR
/* 2487 */    MCD::OPC_Decode, 238, 5, 30, // Opcode: WRASRri
/* 2491 */    MCD::OPC_FilterValue, 49, 79, 0, 0, // Skip to: 2575
/* 2496 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 2499 */    MCD::OPC_FilterValue, 0, 40, 0, 0, // Skip to: 2544
/* 2504 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 2507 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 2523
/* 2512 */    MCD::OPC_CheckField, 5, 8, 0, 96, 20, 0, // Skip to: 7735
/* 2519 */    MCD::OPC_Decode, 243, 5, 12, // Opcode: WRPSRrr
/* 2523 */    MCD::OPC_FilterValue, 1, 87, 20, 0, // Skip to: 7735
/* 2528 */    MCD::OPC_CheckPredicate, 1, 82, 20, 0, // Skip to: 7735
/* 2533 */    MCD::OPC_CheckField, 5, 8, 0, 75, 20, 0, // Skip to: 7735
/* 2540 */    MCD::OPC_Decode, 222, 4, 12, // Opcode: PWRPSRrr
/* 2544 */    MCD::OPC_FilterValue, 1, 66, 20, 0, // Skip to: 7735
/* 2549 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 2552 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 2561
/* 2557 */    MCD::OPC_Decode, 242, 5, 13, // Opcode: WRPSRri
/* 2561 */    MCD::OPC_FilterValue, 1, 49, 20, 0, // Skip to: 7735
/* 2566 */    MCD::OPC_CheckPredicate, 1, 44, 20, 0, // Skip to: 7735
/* 2571 */    MCD::OPC_Decode, 221, 4, 13, // Opcode: PWRPSRri
/* 2575 */    MCD::OPC_FilterValue, 50, 61, 0, 0, // Skip to: 2641
/* 2580 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 2583 */    MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 2616
/* 2588 */    MCD::OPC_ExtractField, 5, 8,  // Inst{12-5} ...
/* 2591 */    MCD::OPC_FilterValue, 0, 19, 20, 0, // Skip to: 7735
/* 2596 */    MCD::OPC_CheckField, 25, 5, 0, 4, 0, 0, // Skip to: 2607
/* 2603 */    MCD::OPC_Decode, 247, 5, 12, // Opcode: WRWIMrr
/* 2607 */    MCD::OPC_CheckPredicate, 0, 3, 20, 0, // Skip to: 7735
/* 2612 */    MCD::OPC_Decode, 241, 5, 31, // Opcode: WRPRrr
/* 2616 */    MCD::OPC_FilterValue, 1, 250, 19, 0, // Skip to: 7735
/* 2621 */    MCD::OPC_CheckField, 25, 5, 0, 4, 0, 0, // Skip to: 2632
/* 2628 */    MCD::OPC_Decode, 246, 5, 13, // Opcode: WRWIMri
/* 2632 */    MCD::OPC_CheckPredicate, 0, 234, 19, 0, // Skip to: 7735
/* 2637 */    MCD::OPC_Decode, 240, 5, 32, // Opcode: WRPRri
/* 2641 */    MCD::OPC_FilterValue, 51, 42, 0, 0, // Skip to: 2688
/* 2646 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 2649 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 2672
/* 2654 */    MCD::OPC_CheckField, 25, 5, 0, 210, 19, 0, // Skip to: 7735
/* 2661 */    MCD::OPC_CheckField, 5, 8, 0, 203, 19, 0, // Skip to: 7735
/* 2668 */    MCD::OPC_Decode, 245, 5, 12, // Opcode: WRTBRrr
/* 2672 */    MCD::OPC_FilterValue, 1, 194, 19, 0, // Skip to: 7735
/* 2677 */    MCD::OPC_CheckField, 25, 5, 0, 187, 19, 0, // Skip to: 7735
/* 2684 */    MCD::OPC_Decode, 244, 5, 13, // Opcode: WRTBRri
/* 2688 */    MCD::OPC_FilterValue, 52, 43, 3, 0, // Skip to: 3504
/* 2693 */    MCD::OPC_ExtractField, 5, 9,  // Inst{13-5} ...
/* 2696 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 2712
/* 2701 */    MCD::OPC_CheckField, 14, 5, 0, 163, 19, 0, // Skip to: 7735
/* 2708 */    MCD::OPC_Decode, 174, 3, 33, // Opcode: FMOVS
/* 2712 */    MCD::OPC_FilterValue, 2, 16, 0, 0, // Skip to: 2733
/* 2717 */    MCD::OPC_CheckPredicate, 0, 149, 19, 0, // Skip to: 7735
/* 2722 */    MCD::OPC_CheckField, 14, 5, 0, 142, 19, 0, // Skip to: 7735
/* 2729 */    MCD::OPC_Decode, 163, 3, 34, // Opcode: FMOVD
/* 2733 */    MCD::OPC_FilterValue, 3, 16, 0, 0, // Skip to: 2754
/* 2738 */    MCD::OPC_CheckPredicate, 0, 128, 19, 0, // Skip to: 7735
/* 2743 */    MCD::OPC_CheckField, 14, 5, 0, 121, 19, 0, // Skip to: 7735
/* 2750 */    MCD::OPC_Decode, 167, 3, 35, // Opcode: FMOVQ
/* 2754 */    MCD::OPC_FilterValue, 5, 11, 0, 0, // Skip to: 2770
/* 2759 */    MCD::OPC_CheckField, 14, 5, 0, 105, 19, 0, // Skip to: 7735
/* 2766 */    MCD::OPC_Decode, 194, 3, 33, // Opcode: FNEGS
/* 2770 */    MCD::OPC_FilterValue, 6, 16, 0, 0, // Skip to: 2791
/* 2775 */    MCD::OPC_CheckPredicate, 0, 91, 19, 0, // Skip to: 7735
/* 2780 */    MCD::OPC_CheckField, 14, 5, 0, 84, 19, 0, // Skip to: 7735
/* 2787 */    MCD::OPC_Decode, 192, 3, 34, // Opcode: FNEGD
/* 2791 */    MCD::OPC_FilterValue, 7, 16, 0, 0, // Skip to: 2812
/* 2796 */    MCD::OPC_CheckPredicate, 0, 70, 19, 0, // Skip to: 7735
/* 2801 */    MCD::OPC_CheckField, 14, 5, 0, 63, 19, 0, // Skip to: 7735
/* 2808 */    MCD::OPC_Decode, 193, 3, 35, // Opcode: FNEGQ
/* 2812 */    MCD::OPC_FilterValue, 9, 11, 0, 0, // Skip to: 2828
/* 2817 */    MCD::OPC_CheckField, 14, 5, 0, 47, 19, 0, // Skip to: 7735
/* 2824 */    MCD::OPC_Decode, 238, 2, 33, // Opcode: FABSS
/* 2828 */    MCD::OPC_FilterValue, 10, 16, 0, 0, // Skip to: 2849
/* 2833 */    MCD::OPC_CheckPredicate, 0, 33, 19, 0, // Skip to: 7735
/* 2838 */    MCD::OPC_CheckField, 14, 5, 0, 26, 19, 0, // Skip to: 7735
/* 2845 */    MCD::OPC_Decode, 236, 2, 34, // Opcode: FABSD
/* 2849 */    MCD::OPC_FilterValue, 11, 16, 0, 0, // Skip to: 2870
/* 2854 */    MCD::OPC_CheckPredicate, 0, 12, 19, 0, // Skip to: 7735
/* 2859 */    MCD::OPC_CheckField, 14, 5, 0, 5, 19, 0, // Skip to: 7735
/* 2866 */    MCD::OPC_Decode, 237, 2, 35, // Opcode: FABSQ
/* 2870 */    MCD::OPC_FilterValue, 41, 11, 0, 0, // Skip to: 2886
/* 2875 */    MCD::OPC_CheckField, 14, 5, 0, 245, 18, 0, // Skip to: 7735
/* 2882 */    MCD::OPC_Decode, 238, 3, 33, // Opcode: FSQRTS
/* 2886 */    MCD::OPC_FilterValue, 42, 11, 0, 0, // Skip to: 2902
/* 2891 */    MCD::OPC_CheckField, 14, 5, 0, 229, 18, 0, // Skip to: 7735
/* 2898 */    MCD::OPC_Decode, 236, 3, 34, // Opcode: FSQRTD
/* 2902 */    MCD::OPC_FilterValue, 43, 11, 0, 0, // Skip to: 2918
/* 2907 */    MCD::OPC_CheckField, 14, 5, 0, 213, 18, 0, // Skip to: 7735
/* 2914 */    MCD::OPC_Decode, 237, 3, 35, // Opcode: FSQRTQ
/* 2918 */    MCD::OPC_FilterValue, 65, 4, 0, 0, // Skip to: 2927
/* 2923 */    MCD::OPC_Decode, 241, 2, 36, // Opcode: FADDS
/* 2927 */    MCD::OPC_FilterValue, 66, 4, 0, 0, // Skip to: 2936
/* 2932 */    MCD::OPC_Decode, 239, 2, 37, // Opcode: FADDD
/* 2936 */    MCD::OPC_FilterValue, 67, 4, 0, 0, // Skip to: 2945
/* 2941 */    MCD::OPC_Decode, 240, 2, 38, // Opcode: FADDQ
/* 2945 */    MCD::OPC_FilterValue, 69, 4, 0, 0, // Skip to: 2954
/* 2950 */    MCD::OPC_Decode, 253, 3, 36, // Opcode: FSUBS
/* 2954 */    MCD::OPC_FilterValue, 70, 4, 0, 0, // Skip to: 2963
/* 2959 */    MCD::OPC_Decode, 251, 3, 37, // Opcode: FSUBD
/* 2963 */    MCD::OPC_FilterValue, 71, 4, 0, 0, // Skip to: 2972
/* 2968 */    MCD::OPC_Decode, 252, 3, 38, // Opcode: FSUBQ
/* 2972 */    MCD::OPC_FilterValue, 73, 4, 0, 0, // Skip to: 2981
/* 2977 */    MCD::OPC_Decode, 187, 3, 36, // Opcode: FMULS
/* 2981 */    MCD::OPC_FilterValue, 74, 4, 0, 0, // Skip to: 2990
/* 2986 */    MCD::OPC_Decode, 183, 3, 37, // Opcode: FMULD
/* 2990 */    MCD::OPC_FilterValue, 75, 4, 0, 0, // Skip to: 2999
/* 2995 */    MCD::OPC_Decode, 186, 3, 38, // Opcode: FMULQ
/* 2999 */    MCD::OPC_FilterValue, 77, 4, 0, 0, // Skip to: 3008
/* 3004 */    MCD::OPC_Decode, 142, 3, 36, // Opcode: FDIVS
/* 3008 */    MCD::OPC_FilterValue, 78, 4, 0, 0, // Skip to: 3017
/* 3013 */    MCD::OPC_Decode, 140, 3, 37, // Opcode: FDIVD
/* 3017 */    MCD::OPC_FilterValue, 79, 4, 0, 0, // Skip to: 3026
/* 3022 */    MCD::OPC_Decode, 141, 3, 38, // Opcode: FDIVQ
/* 3026 */    MCD::OPC_FilterValue, 81, 9, 0, 0, // Skip to: 3040
/* 3031 */    MCD::OPC_CheckPredicate, 2, 91, 18, 0, // Skip to: 7735
/* 3036 */    MCD::OPC_Decode, 189, 3, 37, // Opcode: FNADDS
/* 3040 */    MCD::OPC_FilterValue, 82, 9, 0, 0, // Skip to: 3054
/* 3045 */    MCD::OPC_CheckPredicate, 2, 77, 18, 0, // Skip to: 7735
/* 3050 */    MCD::OPC_Decode, 188, 3, 37, // Opcode: FNADDD
/* 3054 */    MCD::OPC_FilterValue, 89, 9, 0, 0, // Skip to: 3068
/* 3059 */    MCD::OPC_CheckPredicate, 2, 63, 18, 0, // Skip to: 7735
/* 3064 */    MCD::OPC_Decode, 198, 3, 37, // Opcode: FNMULS
/* 3068 */    MCD::OPC_FilterValue, 90, 9, 0, 0, // Skip to: 3082
/* 3073 */    MCD::OPC_CheckPredicate, 2, 49, 18, 0, // Skip to: 7735
/* 3078 */    MCD::OPC_Decode, 197, 3, 37, // Opcode: FNMULD
/* 3082 */    MCD::OPC_FilterValue, 97, 9, 0, 0, // Skip to: 3096
/* 3087 */    MCD::OPC_CheckPredicate, 2, 35, 18, 0, // Skip to: 7735
/* 3092 */    MCD::OPC_Decode, 150, 3, 37, // Opcode: FHADDS
/* 3096 */    MCD::OPC_FilterValue, 98, 9, 0, 0, // Skip to: 3110
/* 3101 */    MCD::OPC_CheckPredicate, 2, 21, 18, 0, // Skip to: 7735
/* 3106 */    MCD::OPC_Decode, 149, 3, 37, // Opcode: FHADDD
/* 3110 */    MCD::OPC_FilterValue, 101, 9, 0, 0, // Skip to: 3124
/* 3115 */    MCD::OPC_CheckPredicate, 2, 7, 18, 0, // Skip to: 7735
/* 3120 */    MCD::OPC_Decode, 152, 3, 37, // Opcode: FHSUBS
/* 3124 */    MCD::OPC_FilterValue, 102, 9, 0, 0, // Skip to: 3138
/* 3129 */    MCD::OPC_CheckPredicate, 2, 249, 17, 0, // Skip to: 7735
/* 3134 */    MCD::OPC_Decode, 151, 3, 37, // Opcode: FHSUBD
/* 3138 */    MCD::OPC_FilterValue, 105, 4, 0, 0, // Skip to: 3147
/* 3143 */    MCD::OPC_Decode, 235, 3, 39, // Opcode: FSMULD
/* 3147 */    MCD::OPC_FilterValue, 110, 4, 0, 0, // Skip to: 3156
/* 3152 */    MCD::OPC_Decode, 143, 3, 40, // Opcode: FDMULQ
/* 3156 */    MCD::OPC_FilterValue, 113, 9, 0, 0, // Skip to: 3170
/* 3161 */    MCD::OPC_CheckPredicate, 2, 217, 17, 0, // Skip to: 7735
/* 3166 */    MCD::OPC_Decode, 196, 3, 37, // Opcode: FNHADDS
/* 3170 */    MCD::OPC_FilterValue, 114, 9, 0, 0, // Skip to: 3184
/* 3175 */    MCD::OPC_CheckPredicate, 2, 203, 17, 0, // Skip to: 7735
/* 3180 */    MCD::OPC_Decode, 195, 3, 37, // Opcode: FNHADDD
/* 3184 */    MCD::OPC_FilterValue, 121, 9, 0, 0, // Skip to: 3198
/* 3189 */    MCD::OPC_CheckPredicate, 2, 189, 17, 0, // Skip to: 7735
/* 3194 */    MCD::OPC_Decode, 205, 3, 37, // Opcode: FNSMULD
/* 3198 */    MCD::OPC_FilterValue, 129, 1, 11, 0, 0, // Skip to: 3215
/* 3204 */    MCD::OPC_CheckField, 14, 5, 0, 172, 17, 0, // Skip to: 7735
/* 3211 */    MCD::OPC_Decode, 250, 3, 41, // Opcode: FSTOX
/* 3215 */    MCD::OPC_FilterValue, 130, 1, 11, 0, 0, // Skip to: 3232
/* 3221 */    MCD::OPC_CheckField, 14, 5, 0, 155, 17, 0, // Skip to: 7735
/* 3228 */    MCD::OPC_Decode, 147, 3, 34, // Opcode: FDTOX
/* 3232 */    MCD::OPC_FilterValue, 131, 1, 11, 0, 0, // Skip to: 3249
/* 3238 */    MCD::OPC_CheckField, 14, 5, 0, 138, 17, 0, // Skip to: 7735
/* 3245 */    MCD::OPC_Decode, 230, 3, 42, // Opcode: FQTOX
/* 3249 */    MCD::OPC_FilterValue, 132, 1, 11, 0, 0, // Skip to: 3266
/* 3255 */    MCD::OPC_CheckField, 14, 5, 0, 121, 17, 0, // Skip to: 7735
/* 3262 */    MCD::OPC_Decode, 132, 4, 43, // Opcode: FXTOS
/* 3266 */    MCD::OPC_FilterValue, 136, 1, 11, 0, 0, // Skip to: 3283
/* 3272 */    MCD::OPC_CheckField, 14, 5, 0, 104, 17, 0, // Skip to: 7735
/* 3279 */    MCD::OPC_Decode, 130, 4, 34, // Opcode: FXTOD
/* 3283 */    MCD::OPC_FilterValue, 140, 1, 11, 0, 0, // Skip to: 3300
/* 3289 */    MCD::OPC_CheckField, 14, 5, 0, 87, 17, 0, // Skip to: 7735
/* 3296 */    MCD::OPC_Decode, 131, 4, 44, // Opcode: FXTOQ
/* 3300 */    MCD::OPC_FilterValue, 196, 1, 11, 0, 0, // Skip to: 3317
/* 3306 */    MCD::OPC_CheckField, 14, 5, 0, 70, 17, 0, // Skip to: 7735
/* 3313 */    MCD::OPC_Decode, 155, 3, 33, // Opcode: FITOS
/* 3317 */    MCD::OPC_FilterValue, 198, 1, 11, 0, 0, // Skip to: 3334
/* 3323 */    MCD::OPC_CheckField, 14, 5, 0, 53, 17, 0, // Skip to: 7735
/* 3330 */    MCD::OPC_Decode, 146, 3, 43, // Opcode: FDTOS
/* 3334 */    MCD::OPC_FilterValue, 199, 1, 11, 0, 0, // Skip to: 3351
/* 3340 */    MCD::OPC_CheckField, 14, 5, 0, 36, 17, 0, // Skip to: 7735
/* 3347 */    MCD::OPC_Decode, 229, 3, 45, // Opcode: FQTOS
/* 3351 */    MCD::OPC_FilterValue, 200, 1, 11, 0, 0, // Skip to: 3368
/* 3357 */    MCD::OPC_CheckField, 14, 5, 0, 19, 17, 0, // Skip to: 7735
/* 3364 */    MCD::OPC_Decode, 153, 3, 41, // Opcode: FITOD
/* 3368 */    MCD::OPC_FilterValue, 201, 1, 11, 0, 0, // Skip to: 3385
/* 3374 */    MCD::OPC_CheckField, 14, 5, 0, 2, 17, 0, // Skip to: 7735
/* 3381 */    MCD::OPC_Decode, 247, 3, 41, // Opcode: FSTOD
/* 3385 */    MCD::OPC_FilterValue, 203, 1, 11, 0, 0, // Skip to: 3402
/* 3391 */    MCD::OPC_CheckField, 14, 5, 0, 241, 16, 0, // Skip to: 7735
/* 3398 */    MCD::OPC_Decode, 227, 3, 42, // Opcode: FQTOD
/* 3402 */    MCD::OPC_FilterValue, 204, 1, 11, 0, 0, // Skip to: 3419
/* 3408 */    MCD::OPC_CheckField, 14, 5, 0, 224, 16, 0, // Skip to: 7735
/* 3415 */    MCD::OPC_Decode, 154, 3, 46, // Opcode: FITOQ
/* 3419 */    MCD::OPC_FilterValue, 205, 1, 11, 0, 0, // Skip to: 3436
/* 3425 */    MCD::OPC_CheckField, 14, 5, 0, 207, 16, 0, // Skip to: 7735
/* 3432 */    MCD::OPC_Decode, 249, 3, 46, // Opcode: FSTOQ
/* 3436 */    MCD::OPC_FilterValue, 206, 1, 11, 0, 0, // Skip to: 3453
/* 3442 */    MCD::OPC_CheckField, 14, 5, 0, 190, 16, 0, // Skip to: 7735
/* 3449 */    MCD::OPC_Decode, 145, 3, 44, // Opcode: FDTOQ
/* 3453 */    MCD::OPC_FilterValue, 209, 1, 11, 0, 0, // Skip to: 3470
/* 3459 */    MCD::OPC_CheckField, 14, 5, 0, 173, 16, 0, // Skip to: 7735
/* 3466 */    MCD::OPC_Decode, 248, 3, 33, // Opcode: FSTOI
/* 3470 */    MCD::OPC_FilterValue, 210, 1, 11, 0, 0, // Skip to: 3487
/* 3476 */    MCD::OPC_CheckField, 14, 5, 0, 156, 16, 0, // Skip to: 7735
/* 3483 */    MCD::OPC_Decode, 144, 3, 43, // Opcode: FDTOI
/* 3487 */    MCD::OPC_FilterValue, 211, 1, 146, 16, 0, // Skip to: 7735
/* 3493 */    MCD::OPC_CheckField, 14, 5, 0, 139, 16, 0, // Skip to: 7735
/* 3500 */    MCD::OPC_Decode, 228, 3, 45, // Opcode: FQTOI
/* 3504 */    MCD::OPC_FilterValue, 53, 188, 1, 0, // Skip to: 3953
/* 3509 */    MCD::OPC_ExtractField, 5, 5,  // Inst{9-5} ...
/* 3512 */    MCD::OPC_FilterValue, 1, 94, 0, 0, // Skip to: 3611
/* 3517 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 3520 */    MCD::OPC_FilterValue, 0, 41, 0, 0, // Skip to: 3566
/* 3525 */    MCD::OPC_ExtractField, 10, 1,  // Inst{10} ...
/* 3528 */    MCD::OPC_FilterValue, 0, 106, 16, 0, // Skip to: 7735
/* 3533 */    MCD::OPC_ExtractField, 18, 1,  // Inst{18} ...
/* 3536 */    MCD::OPC_FilterValue, 0, 98, 16, 0, // Skip to: 7735
/* 3541 */    MCD::OPC_CheckPredicate, 0, 11, 0, 0, // Skip to: 3557
/* 3546 */    MCD::OPC_CheckField, 11, 2, 0, 4, 0, 0, // Skip to: 3557
/* 3553 */    MCD::OPC_Decode, 175, 3, 47, // Opcode: FMOVS_FCC
/* 3557 */    MCD::OPC_CheckPredicate, 0, 77, 16, 0, // Skip to: 7735
/* 3562 */    MCD::OPC_Decode, 235, 5, 48, // Opcode: V9FMOVS_FCC
/* 3566 */    MCD::OPC_FilterValue, 1, 68, 16, 0, // Skip to: 7735
/* 3571 */    MCD::OPC_ExtractField, 10, 3,  // Inst{12-10} ...
/* 3574 */    MCD::OPC_FilterValue, 0, 16, 0, 0, // Skip to: 3595
/* 3579 */    MCD::OPC_CheckPredicate, 0, 55, 16, 0, // Skip to: 7735
/* 3584 */    MCD::OPC_CheckField, 18, 1, 0, 48, 16, 0, // Skip to: 7735
/* 3591 */    MCD::OPC_Decode, 176, 3, 47, // Opcode: FMOVS_ICC
/* 3595 */    MCD::OPC_FilterValue, 4, 39, 16, 0, // Skip to: 7735
/* 3600 */    MCD::OPC_CheckField, 18, 1, 0, 32, 16, 0, // Skip to: 7735
/* 3607 */    MCD::OPC_Decode, 177, 3, 47, // Opcode: FMOVS_XCC
/* 3611 */    MCD::OPC_FilterValue, 2, 94, 0, 0, // Skip to: 3710
/* 3616 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 3619 */    MCD::OPC_FilterValue, 0, 41, 0, 0, // Skip to: 3665
/* 3624 */    MCD::OPC_ExtractField, 10, 1,  // Inst{10} ...
/* 3627 */    MCD::OPC_FilterValue, 0, 7, 16, 0, // Skip to: 7735
/* 3632 */    MCD::OPC_ExtractField, 18, 1,  // Inst{18} ...
/* 3635 */    MCD::OPC_FilterValue, 0, 255, 15, 0, // Skip to: 7735
/* 3640 */    MCD::OPC_CheckPredicate, 0, 11, 0, 0, // Skip to: 3656
/* 3645 */    MCD::OPC_CheckField, 11, 2, 0, 4, 0, 0, // Skip to: 3656
/* 3652 */    MCD::OPC_Decode, 164, 3, 49, // Opcode: FMOVD_FCC
/* 3656 */    MCD::OPC_CheckPredicate, 0, 234, 15, 0, // Skip to: 7735
/* 3661 */    MCD::OPC_Decode, 233, 5, 50, // Opcode: V9FMOVD_FCC
/* 3665 */    MCD::OPC_FilterValue, 1, 225, 15, 0, // Skip to: 7735
/* 3670 */    MCD::OPC_ExtractField, 10, 3,  // Inst{12-10} ...
/* 3673 */    MCD::OPC_FilterValue, 0, 16, 0, 0, // Skip to: 3694
/* 3678 */    MCD::OPC_CheckPredicate, 0, 212, 15, 0, // Skip to: 7735
/* 3683 */    MCD::OPC_CheckField, 18, 1, 0, 205, 15, 0, // Skip to: 7735
/* 3690 */    MCD::OPC_Decode, 165, 3, 49, // Opcode: FMOVD_ICC
/* 3694 */    MCD::OPC_FilterValue, 4, 196, 15, 0, // Skip to: 7735
/* 3699 */    MCD::OPC_CheckField, 18, 1, 0, 189, 15, 0, // Skip to: 7735
/* 3706 */    MCD::OPC_Decode, 166, 3, 49, // Opcode: FMOVD_XCC
/* 3710 */    MCD::OPC_FilterValue, 3, 94, 0, 0, // Skip to: 3809
/* 3715 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 3718 */    MCD::OPC_FilterValue, 0, 41, 0, 0, // Skip to: 3764
/* 3723 */    MCD::OPC_ExtractField, 10, 1,  // Inst{10} ...
/* 3726 */    MCD::OPC_FilterValue, 0, 164, 15, 0, // Skip to: 7735
/* 3731 */    MCD::OPC_ExtractField, 18, 1,  // Inst{18} ...
/* 3734 */    MCD::OPC_FilterValue, 0, 156, 15, 0, // Skip to: 7735
/* 3739 */    MCD::OPC_CheckPredicate, 0, 11, 0, 0, // Skip to: 3755
/* 3744 */    MCD::OPC_CheckField, 11, 2, 0, 4, 0, 0, // Skip to: 3755
/* 3751 */    MCD::OPC_Decode, 168, 3, 51, // Opcode: FMOVQ_FCC
/* 3755 */    MCD::OPC_CheckPredicate, 0, 135, 15, 0, // Skip to: 7735
/* 3760 */    MCD::OPC_Decode, 234, 5, 52, // Opcode: V9FMOVQ_FCC
/* 3764 */    MCD::OPC_FilterValue, 1, 126, 15, 0, // Skip to: 7735
/* 3769 */    MCD::OPC_ExtractField, 10, 3,  // Inst{12-10} ...
/* 3772 */    MCD::OPC_FilterValue, 0, 16, 0, 0, // Skip to: 3793
/* 3777 */    MCD::OPC_CheckPredicate, 0, 113, 15, 0, // Skip to: 7735
/* 3782 */    MCD::OPC_CheckField, 18, 1, 0, 106, 15, 0, // Skip to: 7735
/* 3789 */    MCD::OPC_Decode, 169, 3, 51, // Opcode: FMOVQ_ICC
/* 3793 */    MCD::OPC_FilterValue, 4, 97, 15, 0, // Skip to: 7735
/* 3798 */    MCD::OPC_CheckField, 18, 1, 0, 90, 15, 0, // Skip to: 7735
/* 3805 */    MCD::OPC_Decode, 170, 3, 51, // Opcode: FMOVQ_XCC
/* 3809 */    MCD::OPC_FilterValue, 5, 11, 0, 0, // Skip to: 3825
/* 3814 */    MCD::OPC_CheckField, 13, 1, 0, 74, 15, 0, // Skip to: 7735
/* 3821 */    MCD::OPC_Decode, 173, 3, 53, // Opcode: FMOVRS
/* 3825 */    MCD::OPC_FilterValue, 6, 11, 0, 0, // Skip to: 3841
/* 3830 */    MCD::OPC_CheckField, 13, 1, 0, 58, 15, 0, // Skip to: 7735
/* 3837 */    MCD::OPC_Decode, 171, 3, 54, // Opcode: FMOVRD
/* 3841 */    MCD::OPC_FilterValue, 7, 11, 0, 0, // Skip to: 3857
/* 3846 */    MCD::OPC_CheckField, 13, 1, 0, 42, 15, 0, // Skip to: 7735
/* 3853 */    MCD::OPC_Decode, 172, 3, 55, // Opcode: FMOVRQ
/* 3857 */    MCD::OPC_FilterValue, 17, 11, 0, 0, // Skip to: 3873
/* 3862 */    MCD::OPC_CheckField, 10, 4, 2, 26, 15, 0, // Skip to: 7735
/* 3869 */    MCD::OPC_Decode, 232, 5, 56, // Opcode: V9FCMPS
/* 3873 */    MCD::OPC_FilterValue, 18, 11, 0, 0, // Skip to: 3889
/* 3878 */    MCD::OPC_CheckField, 10, 4, 2, 10, 15, 0, // Skip to: 7735
/* 3885 */    MCD::OPC_Decode, 227, 5, 57, // Opcode: V9FCMPD
/* 3889 */    MCD::OPC_FilterValue, 19, 11, 0, 0, // Skip to: 3905
/* 3894 */    MCD::OPC_CheckField, 10, 4, 2, 250, 14, 0, // Skip to: 7735
/* 3901 */    MCD::OPC_Decode, 231, 5, 58, // Opcode: V9FCMPQ
/* 3905 */    MCD::OPC_FilterValue, 21, 11, 0, 0, // Skip to: 3921
/* 3910 */    MCD::OPC_CheckField, 10, 4, 2, 234, 14, 0, // Skip to: 7735
/* 3917 */    MCD::OPC_Decode, 230, 5, 56, // Opcode: V9FCMPES
/* 3921 */    MCD::OPC_FilterValue, 22, 11, 0, 0, // Skip to: 3937
/* 3926 */    MCD::OPC_CheckField, 10, 4, 2, 218, 14, 0, // Skip to: 7735
/* 3933 */    MCD::OPC_Decode, 228, 5, 57, // Opcode: V9FCMPED
/* 3937 */    MCD::OPC_FilterValue, 23, 209, 14, 0, // Skip to: 7735
/* 3942 */    MCD::OPC_CheckField, 10, 4, 2, 202, 14, 0, // Skip to: 7735
/* 3949 */    MCD::OPC_Decode, 229, 5, 58, // Opcode: V9FCMPEQ
/* 3953 */    MCD::OPC_FilterValue, 54, 35, 7, 0, // Skip to: 5785
/* 3958 */    MCD::OPC_ExtractField, 5, 9,  // Inst{13-5} ...
/* 3961 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 3975
/* 3966 */    MCD::OPC_CheckPredicate, 3, 180, 14, 0, // Skip to: 7735
/* 3971 */    MCD::OPC_Decode, 232, 2, 10, // Opcode: EDGE8
/* 3975 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 3989
/* 3980 */    MCD::OPC_CheckPredicate, 4, 166, 14, 0, // Skip to: 7735
/* 3985 */    MCD::OPC_Decode, 235, 2, 10, // Opcode: EDGE8N
/* 3989 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 4003
/* 3994 */    MCD::OPC_CheckPredicate, 3, 152, 14, 0, // Skip to: 7735
/* 3999 */    MCD::OPC_Decode, 233, 2, 10, // Opcode: EDGE8L
/* 4003 */    MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 4017
/* 4008 */    MCD::OPC_CheckPredicate, 4, 138, 14, 0, // Skip to: 7735
/* 4013 */    MCD::OPC_Decode, 234, 2, 10, // Opcode: EDGE8LN
/* 4017 */    MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 4031
/* 4022 */    MCD::OPC_CheckPredicate, 3, 124, 14, 0, // Skip to: 7735
/* 4027 */    MCD::OPC_Decode, 224, 2, 10, // Opcode: EDGE16
/* 4031 */    MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 4045
/* 4036 */    MCD::OPC_CheckPredicate, 4, 110, 14, 0, // Skip to: 7735
/* 4041 */    MCD::OPC_Decode, 227, 2, 10, // Opcode: EDGE16N
/* 4045 */    MCD::OPC_FilterValue, 6, 9, 0, 0, // Skip to: 4059
/* 4050 */    MCD::OPC_CheckPredicate, 3, 96, 14, 0, // Skip to: 7735
/* 4055 */    MCD::OPC_Decode, 225, 2, 10, // Opcode: EDGE16L
/* 4059 */    MCD::OPC_FilterValue, 7, 9, 0, 0, // Skip to: 4073
/* 4064 */    MCD::OPC_CheckPredicate, 4, 82, 14, 0, // Skip to: 7735
/* 4069 */    MCD::OPC_Decode, 226, 2, 10, // Opcode: EDGE16LN
/* 4073 */    MCD::OPC_FilterValue, 8, 9, 0, 0, // Skip to: 4087
/* 4078 */    MCD::OPC_CheckPredicate, 3, 68, 14, 0, // Skip to: 7735
/* 4083 */    MCD::OPC_Decode, 228, 2, 10, // Opcode: EDGE32
/* 4087 */    MCD::OPC_FilterValue, 9, 9, 0, 0, // Skip to: 4101
/* 4092 */    MCD::OPC_CheckPredicate, 4, 54, 14, 0, // Skip to: 7735
/* 4097 */    MCD::OPC_Decode, 231, 2, 10, // Opcode: EDGE32N
/* 4101 */    MCD::OPC_FilterValue, 10, 9, 0, 0, // Skip to: 4115
/* 4106 */    MCD::OPC_CheckPredicate, 3, 40, 14, 0, // Skip to: 7735
/* 4111 */    MCD::OPC_Decode, 229, 2, 10, // Opcode: EDGE32L
/* 4115 */    MCD::OPC_FilterValue, 11, 9, 0, 0, // Skip to: 4129
/* 4120 */    MCD::OPC_CheckPredicate, 4, 26, 14, 0, // Skip to: 7735
/* 4125 */    MCD::OPC_Decode, 230, 2, 10, // Opcode: EDGE32LN
/* 4129 */    MCD::OPC_FilterValue, 16, 9, 0, 0, // Skip to: 4143
/* 4134 */    MCD::OPC_CheckPredicate, 3, 12, 14, 0, // Skip to: 7735
/* 4139 */    MCD::OPC_Decode, 166, 2, 10, // Opcode: ARRAY8
/* 4143 */    MCD::OPC_FilterValue, 17, 9, 0, 0, // Skip to: 4157
/* 4148 */    MCD::OPC_CheckPredicate, 2, 254, 13, 0, // Skip to: 7735
/* 4153 */    MCD::OPC_Decode, 145, 2, 10, // Opcode: ADDXC
/* 4157 */    MCD::OPC_FilterValue, 18, 9, 0, 0, // Skip to: 4171
/* 4162 */    MCD::OPC_CheckPredicate, 3, 240, 13, 0, // Skip to: 7735
/* 4167 */    MCD::OPC_Decode, 164, 2, 10, // Opcode: ARRAY16
/* 4171 */    MCD::OPC_FilterValue, 19, 9, 0, 0, // Skip to: 4185
/* 4176 */    MCD::OPC_CheckPredicate, 2, 226, 13, 0, // Skip to: 7735
/* 4181 */    MCD::OPC_Decode, 146, 2, 10, // Opcode: ADDXCCC
/* 4185 */    MCD::OPC_FilterValue, 20, 9, 0, 0, // Skip to: 4199
/* 4190 */    MCD::OPC_CheckPredicate, 3, 212, 13, 0, // Skip to: 7735
/* 4195 */    MCD::OPC_Decode, 165, 2, 10, // Opcode: ARRAY32
/* 4199 */    MCD::OPC_FilterValue, 22, 9, 0, 0, // Skip to: 4213
/* 4204 */    MCD::OPC_CheckPredicate, 2, 198, 13, 0, // Skip to: 7735
/* 4209 */    MCD::OPC_Decode, 223, 5, 10, // Opcode: UMULXHI
/* 4213 */    MCD::OPC_FilterValue, 23, 16, 0, 0, // Skip to: 4234
/* 4218 */    MCD::OPC_CheckPredicate, 2, 184, 13, 0, // Skip to: 7735
/* 4223 */    MCD::OPC_CheckField, 14, 5, 0, 177, 13, 0, // Skip to: 7735
/* 4230 */    MCD::OPC_Decode, 185, 4, 59, // Opcode: LZCNT
/* 4234 */    MCD::OPC_FilterValue, 24, 9, 0, 0, // Skip to: 4248
/* 4239 */    MCD::OPC_CheckPredicate, 3, 163, 13, 0, // Skip to: 7735
/* 4244 */    MCD::OPC_Decode, 151, 2, 10, // Opcode: ALIGNADDR
/* 4248 */    MCD::OPC_FilterValue, 25, 9, 0, 0, // Skip to: 4262
/* 4253 */    MCD::OPC_CheckPredicate, 4, 149, 13, 0, // Skip to: 7735
/* 4258 */    MCD::OPC_Decode, 172, 2, 10, // Opcode: BMASK
/* 4262 */    MCD::OPC_FilterValue, 26, 9, 0, 0, // Skip to: 4276
/* 4267 */    MCD::OPC_CheckPredicate, 3, 135, 13, 0, // Skip to: 7735
/* 4272 */    MCD::OPC_Decode, 152, 2, 10, // Opcode: ALIGNADDRL
/* 4276 */    MCD::OPC_FilterValue, 27, 23, 0, 0, // Skip to: 4304
/* 4281 */    MCD::OPC_CheckPredicate, 2, 121, 13, 0, // Skip to: 7735
/* 4286 */    MCD::OPC_CheckField, 25, 5, 0, 114, 13, 0, // Skip to: 7735
/* 4293 */    MCD::OPC_CheckField, 14, 5, 0, 107, 13, 0, // Skip to: 7735
/* 4300 */    MCD::OPC_Decode, 221, 2, 60, // Opcode: CMASK8
/* 4304 */    MCD::OPC_FilterValue, 28, 9, 0, 0, // Skip to: 4318
/* 4309 */    MCD::OPC_CheckPredicate, 4, 93, 13, 0, // Skip to: 7735
/* 4314 */    MCD::OPC_Decode, 209, 2, 37, // Opcode: BSHUFFLE
/* 4318 */    MCD::OPC_FilterValue, 29, 23, 0, 0, // Skip to: 4346
/* 4323 */    MCD::OPC_CheckPredicate, 2, 79, 13, 0, // Skip to: 7735
/* 4328 */    MCD::OPC_CheckField, 25, 5, 0, 72, 13, 0, // Skip to: 7735
/* 4335 */    MCD::OPC_CheckField, 14, 5, 0, 65, 13, 0, // Skip to: 7735
/* 4342 */    MCD::OPC_Decode, 219, 2, 60, // Opcode: CMASK16
/* 4346 */    MCD::OPC_FilterValue, 31, 23, 0, 0, // Skip to: 4374
/* 4351 */    MCD::OPC_CheckPredicate, 2, 51, 13, 0, // Skip to: 7735
/* 4356 */    MCD::OPC_CheckField, 25, 5, 0, 44, 13, 0, // Skip to: 7735
/* 4363 */    MCD::OPC_CheckField, 14, 5, 0, 37, 13, 0, // Skip to: 7735
/* 4370 */    MCD::OPC_Decode, 220, 2, 60, // Opcode: CMASK32
/* 4374 */    MCD::OPC_FilterValue, 32, 9, 0, 0, // Skip to: 4388
/* 4379 */    MCD::OPC_CheckPredicate, 3, 23, 13, 0, // Skip to: 7735
/* 4384 */    MCD::OPC_Decode, 132, 3, 61, // Opcode: FCMPLE16
/* 4388 */    MCD::OPC_FilterValue, 33, 9, 0, 0, // Skip to: 4402
/* 4393 */    MCD::OPC_CheckPredicate, 2, 9, 13, 0, // Skip to: 7735
/* 4398 */    MCD::OPC_Decode, 233, 3, 37, // Opcode: FSLL16
/* 4402 */    MCD::OPC_FilterValue, 34, 9, 0, 0, // Skip to: 4416
/* 4407 */    MCD::OPC_CheckPredicate, 3, 251, 12, 0, // Skip to: 7735
/* 4412 */    MCD::OPC_Decode, 134, 3, 61, // Opcode: FCMPNE16
/* 4416 */    MCD::OPC_FilterValue, 35, 9, 0, 0, // Skip to: 4430
/* 4421 */    MCD::OPC_CheckPredicate, 2, 237, 12, 0, // Skip to: 7735
/* 4426 */    MCD::OPC_Decode, 245, 3, 37, // Opcode: FSRL16
/* 4430 */    MCD::OPC_FilterValue, 36, 9, 0, 0, // Skip to: 4444
/* 4435 */    MCD::OPC_CheckPredicate, 3, 223, 12, 0, // Skip to: 7735
/* 4440 */    MCD::OPC_Decode, 133, 3, 61, // Opcode: FCMPLE32
/* 4444 */    MCD::OPC_FilterValue, 37, 9, 0, 0, // Skip to: 4458
/* 4449 */    MCD::OPC_CheckPredicate, 2, 209, 12, 0, // Skip to: 7735
/* 4454 */    MCD::OPC_Decode, 234, 3, 37, // Opcode: FSLL32
/* 4458 */    MCD::OPC_FilterValue, 38, 9, 0, 0, // Skip to: 4472
/* 4463 */    MCD::OPC_CheckPredicate, 3, 195, 12, 0, // Skip to: 7735
/* 4468 */    MCD::OPC_Decode, 135, 3, 61, // Opcode: FCMPNE32
/* 4472 */    MCD::OPC_FilterValue, 39, 9, 0, 0, // Skip to: 4486
/* 4477 */    MCD::OPC_CheckPredicate, 2, 181, 12, 0, // Skip to: 7735
/* 4482 */    MCD::OPC_Decode, 246, 3, 37, // Opcode: FSRL32
/* 4486 */    MCD::OPC_FilterValue, 40, 9, 0, 0, // Skip to: 4500
/* 4491 */    MCD::OPC_CheckPredicate, 3, 167, 12, 0, // Skip to: 7735
/* 4496 */    MCD::OPC_Decode, 130, 3, 61, // Opcode: FCMPGT16
/* 4500 */    MCD::OPC_FilterValue, 41, 9, 0, 0, // Skip to: 4514
/* 4505 */    MCD::OPC_CheckPredicate, 2, 153, 12, 0, // Skip to: 7735
/* 4510 */    MCD::OPC_Decode, 231, 3, 37, // Opcode: FSLAS16
/* 4514 */    MCD::OPC_FilterValue, 42, 9, 0, 0, // Skip to: 4528
/* 4519 */    MCD::OPC_CheckPredicate, 3, 139, 12, 0, // Skip to: 7735
/* 4524 */    MCD::OPC_Decode, 128, 3, 61, // Opcode: FCMPEQ16
/* 4528 */    MCD::OPC_FilterValue, 43, 9, 0, 0, // Skip to: 4542
/* 4533 */    MCD::OPC_CheckPredicate, 2, 125, 12, 0, // Skip to: 7735
/* 4538 */    MCD::OPC_Decode, 239, 3, 37, // Opcode: FSRA16
/* 4542 */    MCD::OPC_FilterValue, 44, 9, 0, 0, // Skip to: 4556
/* 4547 */    MCD::OPC_CheckPredicate, 3, 111, 12, 0, // Skip to: 7735
/* 4552 */    MCD::OPC_Decode, 131, 3, 61, // Opcode: FCMPGT32
/* 4556 */    MCD::OPC_FilterValue, 45, 9, 0, 0, // Skip to: 4570
/* 4561 */    MCD::OPC_CheckPredicate, 2, 97, 12, 0, // Skip to: 7735
/* 4566 */    MCD::OPC_Decode, 232, 3, 37, // Opcode: FSLAS32
/* 4570 */    MCD::OPC_FilterValue, 46, 9, 0, 0, // Skip to: 4584
/* 4575 */    MCD::OPC_CheckPredicate, 3, 83, 12, 0, // Skip to: 7735
/* 4580 */    MCD::OPC_Decode, 129, 3, 61, // Opcode: FCMPEQ32
/* 4584 */    MCD::OPC_FilterValue, 47, 9, 0, 0, // Skip to: 4598
/* 4589 */    MCD::OPC_CheckPredicate, 2, 69, 12, 0, // Skip to: 7735
/* 4594 */    MCD::OPC_Decode, 240, 3, 37, // Opcode: FSRA32
/* 4598 */    MCD::OPC_FilterValue, 49, 9, 0, 0, // Skip to: 4612
/* 4603 */    MCD::OPC_CheckPredicate, 3, 55, 12, 0, // Skip to: 7735
/* 4608 */    MCD::OPC_Decode, 180, 3, 37, // Opcode: FMUL8X16
/* 4612 */    MCD::OPC_FilterValue, 51, 9, 0, 0, // Skip to: 4626
/* 4617 */    MCD::OPC_CheckPredicate, 3, 41, 12, 0, // Skip to: 7735
/* 4622 */    MCD::OPC_Decode, 182, 3, 37, // Opcode: FMUL8X16AU
/* 4626 */    MCD::OPC_FilterValue, 53, 9, 0, 0, // Skip to: 4640
/* 4631 */    MCD::OPC_CheckPredicate, 3, 27, 12, 0, // Skip to: 7735
/* 4636 */    MCD::OPC_Decode, 181, 3, 37, // Opcode: FMUL8X16AL
/* 4640 */    MCD::OPC_FilterValue, 54, 9, 0, 0, // Skip to: 4654
/* 4645 */    MCD::OPC_CheckPredicate, 3, 13, 12, 0, // Skip to: 7735
/* 4650 */    MCD::OPC_Decode, 178, 3, 37, // Opcode: FMUL8SUX16
/* 4654 */    MCD::OPC_FilterValue, 55, 9, 0, 0, // Skip to: 4668
/* 4659 */    MCD::OPC_CheckPredicate, 3, 255, 11, 0, // Skip to: 7735
/* 4664 */    MCD::OPC_Decode, 179, 3, 37, // Opcode: FMUL8ULX16
/* 4668 */    MCD::OPC_FilterValue, 56, 9, 0, 0, // Skip to: 4682
/* 4673 */    MCD::OPC_CheckPredicate, 3, 241, 11, 0, // Skip to: 7735
/* 4678 */    MCD::OPC_Decode, 184, 3, 37, // Opcode: FMULD8SUX16
/* 4682 */    MCD::OPC_FilterValue, 57, 9, 0, 0, // Skip to: 4696
/* 4687 */    MCD::OPC_CheckPredicate, 3, 227, 11, 0, // Skip to: 7735
/* 4692 */    MCD::OPC_Decode, 185, 3, 37, // Opcode: FMULD8ULX16
/* 4696 */    MCD::OPC_FilterValue, 58, 9, 0, 0, // Skip to: 4710
/* 4701 */    MCD::OPC_CheckPredicate, 3, 213, 11, 0, // Skip to: 7735
/* 4706 */    MCD::OPC_Decode, 215, 3, 37, // Opcode: FPACK32
/* 4710 */    MCD::OPC_FilterValue, 59, 16, 0, 0, // Skip to: 4731
/* 4715 */    MCD::OPC_CheckPredicate, 3, 199, 11, 0, // Skip to: 7735
/* 4720 */    MCD::OPC_CheckField, 14, 5, 0, 192, 11, 0, // Skip to: 7735
/* 4727 */    MCD::OPC_Decode, 214, 3, 34, // Opcode: FPACK16
/* 4731 */    MCD::OPC_FilterValue, 61, 16, 0, 0, // Skip to: 4752
/* 4736 */    MCD::OPC_CheckPredicate, 3, 178, 11, 0, // Skip to: 7735
/* 4741 */    MCD::OPC_CheckField, 14, 5, 0, 171, 11, 0, // Skip to: 7735
/* 4748 */    MCD::OPC_Decode, 216, 3, 34, // Opcode: FPACKFIX
/* 4752 */    MCD::OPC_FilterValue, 62, 9, 0, 0, // Skip to: 4766
/* 4757 */    MCD::OPC_CheckPredicate, 3, 157, 11, 0, // Skip to: 7735
/* 4762 */    MCD::OPC_Decode, 216, 4, 37, // Opcode: PDIST
/* 4766 */    MCD::OPC_FilterValue, 63, 9, 0, 0, // Skip to: 4780
/* 4771 */    MCD::OPC_CheckPredicate, 2, 143, 11, 0, // Skip to: 7735
/* 4776 */    MCD::OPC_Decode, 217, 4, 37, // Opcode: PDISTN
/* 4780 */    MCD::OPC_FilterValue, 64, 9, 0, 0, // Skip to: 4794
/* 4785 */    MCD::OPC_CheckPredicate, 2, 129, 11, 0, // Skip to: 7735
/* 4790 */    MCD::OPC_Decode, 162, 3, 37, // Opcode: FMEAN16
/* 4794 */    MCD::OPC_FilterValue, 66, 9, 0, 0, // Skip to: 4808
/* 4799 */    MCD::OPC_CheckPredicate, 2, 115, 11, 0, // Skip to: 7735
/* 4804 */    MCD::OPC_Decode, 221, 3, 37, // Opcode: FPADD64
/* 4808 */    MCD::OPC_FilterValue, 68, 9, 0, 0, // Skip to: 4822
/* 4813 */    MCD::OPC_CheckPredicate, 2, 101, 11, 0, // Skip to: 7735
/* 4818 */    MCD::OPC_Decode, 253, 2, 37, // Opcode: FCHKSM16
/* 4822 */    MCD::OPC_FilterValue, 72, 9, 0, 0, // Skip to: 4836
/* 4827 */    MCD::OPC_CheckPredicate, 3, 87, 11, 0, // Skip to: 7735
/* 4832 */    MCD::OPC_Decode, 242, 2, 37, // Opcode: FALIGNADATA
/* 4836 */    MCD::OPC_FilterValue, 75, 9, 0, 0, // Skip to: 4850
/* 4841 */    MCD::OPC_CheckPredicate, 3, 73, 11, 0, // Skip to: 7735
/* 4846 */    MCD::OPC_Decode, 222, 3, 37, // Opcode: FPMERGE
/* 4850 */    MCD::OPC_FilterValue, 77, 16, 0, 0, // Skip to: 4871
/* 4855 */    MCD::OPC_CheckPredicate, 3, 59, 11, 0, // Skip to: 7735
/* 4860 */    MCD::OPC_CheckField, 14, 5, 0, 52, 11, 0, // Skip to: 7735
/* 4867 */    MCD::OPC_Decode, 148, 3, 34, // Opcode: FEXPAND
/* 4871 */    MCD::OPC_FilterValue, 80, 9, 0, 0, // Skip to: 4885
/* 4876 */    MCD::OPC_CheckPredicate, 3, 38, 11, 0, // Skip to: 7735
/* 4881 */    MCD::OPC_Decode, 217, 3, 37, // Opcode: FPADD16
/* 4885 */    MCD::OPC_FilterValue, 81, 9, 0, 0, // Skip to: 4899
/* 4890 */    MCD::OPC_CheckPredicate, 3, 24, 11, 0, // Skip to: 7735
/* 4895 */    MCD::OPC_Decode, 218, 3, 37, // Opcode: FPADD16S
/* 4899 */    MCD::OPC_FilterValue, 82, 9, 0, 0, // Skip to: 4913
/* 4904 */    MCD::OPC_CheckPredicate, 3, 10, 11, 0, // Skip to: 7735
/* 4909 */    MCD::OPC_Decode, 219, 3, 37, // Opcode: FPADD32
/* 4913 */    MCD::OPC_FilterValue, 83, 9, 0, 0, // Skip to: 4927
/* 4918 */    MCD::OPC_CheckPredicate, 3, 252, 10, 0, // Skip to: 7735
/* 4923 */    MCD::OPC_Decode, 220, 3, 37, // Opcode: FPADD32S
/* 4927 */    MCD::OPC_FilterValue, 84, 9, 0, 0, // Skip to: 4941
/* 4932 */    MCD::OPC_CheckPredicate, 3, 238, 10, 0, // Skip to: 7735
/* 4937 */    MCD::OPC_Decode, 223, 3, 37, // Opcode: FPSUB16
/* 4941 */    MCD::OPC_FilterValue, 85, 9, 0, 0, // Skip to: 4955
/* 4946 */    MCD::OPC_CheckPredicate, 3, 224, 10, 0, // Skip to: 7735
/* 4951 */    MCD::OPC_Decode, 224, 3, 37, // Opcode: FPSUB16S
/* 4955 */    MCD::OPC_FilterValue, 86, 9, 0, 0, // Skip to: 4969
/* 4960 */    MCD::OPC_CheckPredicate, 3, 210, 10, 0, // Skip to: 7735
/* 4965 */    MCD::OPC_Decode, 225, 3, 37, // Opcode: FPSUB32
/* 4969 */    MCD::OPC_FilterValue, 87, 9, 0, 0, // Skip to: 4983
/* 4974 */    MCD::OPC_CheckPredicate, 3, 196, 10, 0, // Skip to: 7735
/* 4979 */    MCD::OPC_Decode, 226, 3, 37, // Opcode: FPSUB32S
/* 4983 */    MCD::OPC_FilterValue, 96, 23, 0, 0, // Skip to: 5011
/* 4988 */    MCD::OPC_CheckPredicate, 3, 182, 10, 0, // Skip to: 7735
/* 4993 */    MCD::OPC_CheckField, 14, 5, 0, 175, 10, 0, // Skip to: 7735
/* 5000 */    MCD::OPC_CheckField, 0, 5, 0, 168, 10, 0, // Skip to: 7735
/* 5007 */    MCD::OPC_Decode, 133, 4, 62, // Opcode: FZERO
/* 5011 */    MCD::OPC_FilterValue, 97, 23, 0, 0, // Skip to: 5039
/* 5016 */    MCD::OPC_CheckPredicate, 3, 154, 10, 0, // Skip to: 7735
/* 5021 */    MCD::OPC_CheckField, 14, 5, 0, 147, 10, 0, // Skip to: 7735
/* 5028 */    MCD::OPC_CheckField, 0, 5, 0, 140, 10, 0, // Skip to: 7735
/* 5035 */    MCD::OPC_Decode, 134, 4, 63, // Opcode: FZEROS
/* 5039 */    MCD::OPC_FilterValue, 98, 9, 0, 0, // Skip to: 5053
/* 5044 */    MCD::OPC_CheckPredicate, 3, 126, 10, 0, // Skip to: 7735
/* 5049 */    MCD::OPC_Decode, 199, 3, 37, // Opcode: FNOR
/* 5053 */    MCD::OPC_FilterValue, 99, 9, 0, 0, // Skip to: 5067
/* 5058 */    MCD::OPC_CheckPredicate, 3, 112, 10, 0, // Skip to: 7735
/* 5063 */    MCD::OPC_Decode, 200, 3, 36, // Opcode: FNORS
/* 5067 */    MCD::OPC_FilterValue, 100, 9, 0, 0, // Skip to: 5081
/* 5072 */    MCD::OPC_CheckPredicate, 3, 98, 10, 0, // Skip to: 7735
/* 5077 */    MCD::OPC_Decode, 246, 2, 37, // Opcode: FANDNOT2
/* 5081 */    MCD::OPC_FilterValue, 101, 9, 0, 0, // Skip to: 5095
/* 5086 */    MCD::OPC_CheckPredicate, 3, 84, 10, 0, // Skip to: 7735
/* 5091 */    MCD::OPC_Decode, 247, 2, 36, // Opcode: FANDNOT2S
/* 5095 */    MCD::OPC_FilterValue, 102, 16, 0, 0, // Skip to: 5116
/* 5100 */    MCD::OPC_CheckPredicate, 3, 70, 10, 0, // Skip to: 7735
/* 5105 */    MCD::OPC_CheckField, 14, 5, 0, 63, 10, 0, // Skip to: 7735
/* 5112 */    MCD::OPC_Decode, 203, 3, 34, // Opcode: FNOT2
/* 5116 */    MCD::OPC_FilterValue, 103, 16, 0, 0, // Skip to: 5137
/* 5121 */    MCD::OPC_CheckPredicate, 3, 49, 10, 0, // Skip to: 7735
/* 5126 */    MCD::OPC_CheckField, 14, 5, 0, 42, 10, 0, // Skip to: 7735
/* 5133 */    MCD::OPC_Decode, 204, 3, 33, // Opcode: FNOT2S
/* 5137 */    MCD::OPC_FilterValue, 104, 9, 0, 0, // Skip to: 5151
/* 5142 */    MCD::OPC_CheckPredicate, 3, 28, 10, 0, // Skip to: 7735
/* 5147 */    MCD::OPC_Decode, 244, 2, 37, // Opcode: FANDNOT1
/* 5151 */    MCD::OPC_FilterValue, 105, 9, 0, 0, // Skip to: 5165
/* 5156 */    MCD::OPC_CheckPredicate, 3, 14, 10, 0, // Skip to: 7735
/* 5161 */    MCD::OPC_Decode, 245, 2, 36, // Opcode: FANDNOT1S
/* 5165 */    MCD::OPC_FilterValue, 106, 16, 0, 0, // Skip to: 5186
/* 5170 */    MCD::OPC_CheckPredicate, 3, 0, 10, 0, // Skip to: 7735
/* 5175 */    MCD::OPC_CheckField, 0, 5, 0, 249, 9, 0, // Skip to: 7735
/* 5182 */    MCD::OPC_Decode, 201, 3, 64, // Opcode: FNOT1
/* 5186 */    MCD::OPC_FilterValue, 107, 16, 0, 0, // Skip to: 5207
/* 5191 */    MCD::OPC_CheckPredicate, 3, 235, 9, 0, // Skip to: 7735
/* 5196 */    MCD::OPC_CheckField, 0, 5, 0, 228, 9, 0, // Skip to: 7735
/* 5203 */    MCD::OPC_Decode, 202, 3, 65, // Opcode: FNOT1S
/* 5207 */    MCD::OPC_FilterValue, 108, 9, 0, 0, // Skip to: 5221
/* 5212 */    MCD::OPC_CheckPredicate, 3, 214, 9, 0, // Skip to: 7735
/* 5217 */    MCD::OPC_Decode, 128, 4, 37, // Opcode: FXOR
/* 5221 */    MCD::OPC_FilterValue, 109, 9, 0, 0, // Skip to: 5235
/* 5226 */    MCD::OPC_CheckPredicate, 3, 200, 9, 0, // Skip to: 7735
/* 5231 */    MCD::OPC_Decode, 129, 4, 36, // Opcode: FXORS
/* 5235 */    MCD::OPC_FilterValue, 110, 9, 0, 0, // Skip to: 5249
/* 5240 */    MCD::OPC_CheckPredicate, 3, 186, 9, 0, // Skip to: 7735
/* 5245 */    MCD::OPC_Decode, 190, 3, 37, // Opcode: FNAND
/* 5249 */    MCD::OPC_FilterValue, 111, 9, 0, 0, // Skip to: 5263
/* 5254 */    MCD::OPC_CheckPredicate, 3, 172, 9, 0, // Skip to: 7735
/* 5259 */    MCD::OPC_Decode, 191, 3, 36, // Opcode: FNANDS
/* 5263 */    MCD::OPC_FilterValue, 112, 9, 0, 0, // Skip to: 5277
/* 5268 */    MCD::OPC_CheckPredicate, 3, 158, 9, 0, // Skip to: 7735
/* 5273 */    MCD::OPC_Decode, 243, 2, 37, // Opcode: FAND
/* 5277 */    MCD::OPC_FilterValue, 113, 9, 0, 0, // Skip to: 5291
/* 5282 */    MCD::OPC_CheckPredicate, 3, 144, 9, 0, // Skip to: 7735
/* 5287 */    MCD::OPC_Decode, 248, 2, 36, // Opcode: FANDS
/* 5291 */    MCD::OPC_FilterValue, 114, 9, 0, 0, // Skip to: 5305
/* 5296 */    MCD::OPC_CheckPredicate, 3, 130, 9, 0, // Skip to: 7735
/* 5301 */    MCD::OPC_Decode, 254, 3, 37, // Opcode: FXNOR
/* 5305 */    MCD::OPC_FilterValue, 115, 9, 0, 0, // Skip to: 5319
/* 5310 */    MCD::OPC_CheckPredicate, 3, 116, 9, 0, // Skip to: 7735
/* 5315 */    MCD::OPC_Decode, 255, 3, 36, // Opcode: FXNORS
/* 5319 */    MCD::OPC_FilterValue, 116, 16, 0, 0, // Skip to: 5340
/* 5324 */    MCD::OPC_CheckPredicate, 3, 102, 9, 0, // Skip to: 7735
/* 5329 */    MCD::OPC_CheckField, 0, 5, 0, 95, 9, 0, // Skip to: 7735
/* 5336 */    MCD::OPC_Decode, 241, 3, 64, // Opcode: FSRC1
/* 5340 */    MCD::OPC_FilterValue, 117, 16, 0, 0, // Skip to: 5361
/* 5345 */    MCD::OPC_CheckPredicate, 3, 81, 9, 0, // Skip to: 7735
/* 5350 */    MCD::OPC_CheckField, 0, 5, 0, 74, 9, 0, // Skip to: 7735
/* 5357 */    MCD::OPC_Decode, 242, 3, 65, // Opcode: FSRC1S
/* 5361 */    MCD::OPC_FilterValue, 118, 9, 0, 0, // Skip to: 5375
/* 5366 */    MCD::OPC_CheckPredicate, 3, 60, 9, 0, // Skip to: 7735
/* 5371 */    MCD::OPC_Decode, 211, 3, 37, // Opcode: FORNOT2
/* 5375 */    MCD::OPC_FilterValue, 119, 9, 0, 0, // Skip to: 5389
/* 5380 */    MCD::OPC_CheckPredicate, 3, 46, 9, 0, // Skip to: 7735
/* 5385 */    MCD::OPC_Decode, 212, 3, 36, // Opcode: FORNOT2S
/* 5389 */    MCD::OPC_FilterValue, 120, 16, 0, 0, // Skip to: 5410
/* 5394 */    MCD::OPC_CheckPredicate, 3, 32, 9, 0, // Skip to: 7735
/* 5399 */    MCD::OPC_CheckField, 14, 5, 0, 25, 9, 0, // Skip to: 7735
/* 5406 */    MCD::OPC_Decode, 243, 3, 34, // Opcode: FSRC2
/* 5410 */    MCD::OPC_FilterValue, 121, 16, 0, 0, // Skip to: 5431
/* 5415 */    MCD::OPC_CheckPredicate, 3, 11, 9, 0, // Skip to: 7735
/* 5420 */    MCD::OPC_CheckField, 14, 5, 0, 4, 9, 0, // Skip to: 7735
/* 5427 */    MCD::OPC_Decode, 244, 3, 33, // Opcode: FSRC2S
/* 5431 */    MCD::OPC_FilterValue, 122, 9, 0, 0, // Skip to: 5445
/* 5436 */    MCD::OPC_CheckPredicate, 3, 246, 8, 0, // Skip to: 7735
/* 5441 */    MCD::OPC_Decode, 209, 3, 37, // Opcode: FORNOT1
/* 5445 */    MCD::OPC_FilterValue, 123, 9, 0, 0, // Skip to: 5459
/* 5450 */    MCD::OPC_CheckPredicate, 3, 232, 8, 0, // Skip to: 7735
/* 5455 */    MCD::OPC_Decode, 210, 3, 36, // Opcode: FORNOT1S
/* 5459 */    MCD::OPC_FilterValue, 124, 9, 0, 0, // Skip to: 5473
/* 5464 */    MCD::OPC_CheckPredicate, 3, 218, 8, 0, // Skip to: 7735
/* 5469 */    MCD::OPC_Decode, 208, 3, 37, // Opcode: FOR
/* 5473 */    MCD::OPC_FilterValue, 125, 9, 0, 0, // Skip to: 5487
/* 5478 */    MCD::OPC_CheckPredicate, 3, 204, 8, 0, // Skip to: 7735
/* 5483 */    MCD::OPC_Decode, 213, 3, 36, // Opcode: FORS
/* 5487 */    MCD::OPC_FilterValue, 126, 23, 0, 0, // Skip to: 5515
/* 5492 */    MCD::OPC_CheckPredicate, 3, 190, 8, 0, // Skip to: 7735
/* 5497 */    MCD::OPC_CheckField, 14, 5, 0, 183, 8, 0, // Skip to: 7735
/* 5504 */    MCD::OPC_CheckField, 0, 5, 0, 176, 8, 0, // Skip to: 7735
/* 5511 */    MCD::OPC_Decode, 206, 3, 62, // Opcode: FONE
/* 5515 */    MCD::OPC_FilterValue, 127, 23, 0, 0, // Skip to: 5543
/* 5520 */    MCD::OPC_CheckPredicate, 3, 162, 8, 0, // Skip to: 7735
/* 5525 */    MCD::OPC_CheckField, 14, 5, 0, 155, 8, 0, // Skip to: 7735
/* 5532 */    MCD::OPC_CheckField, 0, 5, 0, 148, 8, 0, // Skip to: 7735
/* 5539 */    MCD::OPC_Decode, 207, 3, 63, // Opcode: FONES
/* 5543 */    MCD::OPC_FilterValue, 128, 1, 30, 0, 0, // Skip to: 5579
/* 5549 */    MCD::OPC_CheckPredicate, 3, 133, 8, 0, // Skip to: 7735
/* 5554 */    MCD::OPC_CheckField, 25, 5, 0, 126, 8, 0, // Skip to: 7735
/* 5561 */    MCD::OPC_CheckField, 14, 5, 0, 119, 8, 0, // Skip to: 7735
/* 5568 */    MCD::OPC_CheckField, 0, 5, 0, 112, 8, 0, // Skip to: 7735
/* 5575 */    MCD::OPC_Decode, 245, 4, 4, // Opcode: SHUTDOWN
/* 5579 */    MCD::OPC_FilterValue, 129, 1, 30, 0, 0, // Skip to: 5615
/* 5585 */    MCD::OPC_CheckPredicate, 4, 97, 8, 0, // Skip to: 7735
/* 5590 */    MCD::OPC_CheckField, 25, 5, 0, 90, 8, 0, // Skip to: 7735
/* 5597 */    MCD::OPC_CheckField, 14, 5, 0, 83, 8, 0, // Skip to: 7735
/* 5604 */    MCD::OPC_CheckField, 0, 5, 0, 76, 8, 0, // Skip to: 7735
/* 5611 */    MCD::OPC_Decode, 246, 4, 4, // Opcode: SIAM
/* 5615 */    MCD::OPC_FilterValue, 144, 2, 16, 0, 0, // Skip to: 5637
/* 5621 */    MCD::OPC_CheckPredicate, 2, 61, 8, 0, // Skip to: 7735
/* 5626 */    MCD::OPC_CheckField, 14, 5, 0, 54, 8, 0, // Skip to: 7735
/* 5633 */    MCD::OPC_Decode, 187, 4, 66, // Opcode: MOVDTOX
/* 5637 */    MCD::OPC_FilterValue, 145, 2, 16, 0, 0, // Skip to: 5659
/* 5643 */    MCD::OPC_CheckPredicate, 2, 39, 8, 0, // Skip to: 7735
/* 5648 */    MCD::OPC_CheckField, 14, 5, 0, 32, 8, 0, // Skip to: 7735
/* 5655 */    MCD::OPC_Decode, 195, 4, 66, // Opcode: MOVSTOUW
/* 5659 */    MCD::OPC_FilterValue, 147, 2, 16, 0, 0, // Skip to: 5681
/* 5665 */    MCD::OPC_CheckPredicate, 2, 17, 8, 0, // Skip to: 7735
/* 5670 */    MCD::OPC_CheckField, 14, 5, 0, 10, 8, 0, // Skip to: 7735
/* 5677 */    MCD::OPC_Decode, 194, 4, 66, // Opcode: MOVSTOSW
/* 5681 */    MCD::OPC_FilterValue, 149, 2, 9, 0, 0, // Skip to: 5696
/* 5687 */    MCD::OPC_CheckPredicate, 2, 251, 7, 0, // Skip to: 7735
/* 5692 */    MCD::OPC_Decode, 248, 5, 10, // Opcode: XMULX
/* 5696 */    MCD::OPC_FilterValue, 151, 2, 9, 0, 0, // Skip to: 5711
/* 5702 */    MCD::OPC_CheckPredicate, 2, 236, 7, 0, // Skip to: 7735
/* 5707 */    MCD::OPC_Decode, 249, 5, 10, // Opcode: XMULXHI
/* 5711 */    MCD::OPC_FilterValue, 152, 2, 16, 0, 0, // Skip to: 5733
/* 5717 */    MCD::OPC_CheckPredicate, 2, 221, 7, 0, // Skip to: 7735
/* 5722 */    MCD::OPC_CheckField, 14, 5, 0, 214, 7, 0, // Skip to: 7735
/* 5729 */    MCD::OPC_Decode, 199, 4, 67, // Opcode: MOVXTOD
/* 5733 */    MCD::OPC_FilterValue, 153, 2, 16, 0, 0, // Skip to: 5755
/* 5739 */    MCD::OPC_CheckPredicate, 2, 199, 7, 0, // Skip to: 7735
/* 5744 */    MCD::OPC_CheckField, 14, 5, 0, 192, 7, 0, // Skip to: 7735
/* 5751 */    MCD::OPC_Decode, 196, 4, 67, // Opcode: MOVWTOS
/* 5755 */    MCD::OPC_FilterValue, 209, 2, 9, 0, 0, // Skip to: 5770
/* 5761 */    MCD::OPC_CheckPredicate, 2, 177, 7, 0, // Skip to: 7735
/* 5766 */    MCD::OPC_Decode, 157, 3, 57, // Opcode: FLCMPS
/* 5770 */    MCD::OPC_FilterValue, 210, 2, 167, 7, 0, // Skip to: 7735
/* 5776 */    MCD::OPC_CheckPredicate, 2, 162, 7, 0, // Skip to: 7735
/* 5781 */    MCD::OPC_Decode, 156, 3, 57, // Opcode: FLCMPD
/* 5785 */    MCD::OPC_FilterValue, 56, 28, 0, 0, // Skip to: 5818
/* 5790 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5793 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5809
/* 5798 */    MCD::OPC_CheckField, 5, 8, 0, 138, 7, 0, // Skip to: 7735
/* 5805 */    MCD::OPC_Decode, 138, 4, 68, // Opcode: JMPLrr
/* 5809 */    MCD::OPC_FilterValue, 1, 129, 7, 0, // Skip to: 7735
/* 5814 */    MCD::OPC_Decode, 137, 4, 69, // Opcode: JMPLri
/* 5818 */    MCD::OPC_FilterValue, 57, 42, 0, 0, // Skip to: 5865
/* 5823 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5826 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 5849
/* 5831 */    MCD::OPC_CheckField, 25, 5, 0, 105, 7, 0, // Skip to: 7735
/* 5838 */    MCD::OPC_CheckField, 5, 8, 0, 98, 7, 0, // Skip to: 7735
/* 5845 */    MCD::OPC_Decode, 234, 4, 70, // Opcode: RETTrr
/* 5849 */    MCD::OPC_FilterValue, 1, 89, 7, 0, // Skip to: 7735
/* 5854 */    MCD::OPC_CheckField, 25, 5, 0, 82, 7, 0, // Skip to: 7735
/* 5861 */    MCD::OPC_Decode, 233, 4, 71, // Opcode: RETTri
/* 5865 */    MCD::OPC_FilterValue, 58, 119, 0, 0, // Skip to: 5989
/* 5870 */    MCD::OPC_ExtractField, 8, 6,  // Inst{13-8} ...
/* 5873 */    MCD::OPC_FilterValue, 16, 18, 0, 0, // Skip to: 5896
/* 5878 */    MCD::OPC_CheckField, 29, 1, 0, 58, 7, 0, // Skip to: 7735
/* 5885 */    MCD::OPC_CheckField, 5, 3, 0, 51, 7, 0, // Skip to: 7735
/* 5892 */    MCD::OPC_Decode, 212, 5, 72, // Opcode: TXCCrr
/* 5896 */    MCD::OPC_FilterValue, 32, 72, 0, 0, // Skip to: 5973
/* 5901 */    MCD::OPC_ExtractField, 0, 8,  // Inst{7-0} ...
/* 5904 */    MCD::OPC_FilterValue, 1, 18, 0, 0, // Skip to: 5927
/* 5909 */    MCD::OPC_CheckField, 25, 5, 8, 27, 7, 0, // Skip to: 7735
/* 5916 */    MCD::OPC_CheckField, 14, 5, 0, 20, 7, 0, // Skip to: 7735
/* 5923 */    MCD::OPC_Decode, 189, 5, 4, // Opcode: TA1
/* 5927 */    MCD::OPC_FilterValue, 3, 18, 0, 0, // Skip to: 5950
/* 5932 */    MCD::OPC_CheckField, 25, 5, 8, 4, 7, 0, // Skip to: 7735
/* 5939 */    MCD::OPC_CheckField, 14, 5, 0, 253, 6, 0, // Skip to: 7735
/* 5946 */    MCD::OPC_Decode, 190, 5, 4, // Opcode: TA3
/* 5950 */    MCD::OPC_FilterValue, 5, 244, 6, 0, // Skip to: 7735
/* 5955 */    MCD::OPC_CheckField, 25, 5, 8, 237, 6, 0, // Skip to: 7735
/* 5962 */    MCD::OPC_CheckField, 14, 5, 0, 230, 6, 0, // Skip to: 7735
/* 5969 */    MCD::OPC_Decode, 191, 5, 4, // Opcode: TA5
/* 5973 */    MCD::OPC_FilterValue, 48, 221, 6, 0, // Skip to: 7735
/* 5978 */    MCD::OPC_CheckField, 29, 1, 0, 214, 6, 0, // Skip to: 7735
/* 5985 */    MCD::OPC_Decode, 211, 5, 73, // Opcode: TXCCri
/* 5989 */    MCD::OPC_FilterValue, 59, 62, 0, 0, // Skip to: 6056
/* 5994 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5997 */    MCD::OPC_FilterValue, 0, 38, 0, 0, // Skip to: 6040
/* 6002 */    MCD::OPC_ExtractField, 5, 8,  // Inst{12-5} ...
/* 6005 */    MCD::OPC_FilterValue, 0, 189, 6, 0, // Skip to: 7735
/* 6010 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 6013 */    MCD::OPC_FilterValue, 0, 181, 6, 0, // Skip to: 7735
/* 6018 */    MCD::OPC_CheckField, 14, 5, 0, 11, 0, 0, // Skip to: 6036
/* 6025 */    MCD::OPC_CheckField, 0, 5, 0, 4, 0, 0, // Skip to: 6036
/* 6032 */    MCD::OPC_Decode, 158, 3, 4, // Opcode: FLUSH
/* 6036 */    MCD::OPC_Decode, 161, 3, 70, // Opcode: FLUSHrr
/* 6040 */    MCD::OPC_FilterValue, 1, 154, 6, 0, // Skip to: 7735
/* 6045 */    MCD::OPC_CheckField, 25, 5, 0, 147, 6, 0, // Skip to: 7735
/* 6052 */    MCD::OPC_Decode, 160, 3, 71, // Opcode: FLUSHri
/* 6056 */    MCD::OPC_FilterValue, 60, 28, 0, 0, // Skip to: 6089
/* 6061 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6064 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6080
/* 6069 */    MCD::OPC_CheckField, 5, 8, 0, 123, 6, 0, // Skip to: 7735
/* 6076 */    MCD::OPC_Decode, 236, 4, 8, // Opcode: SAVErr
/* 6080 */    MCD::OPC_FilterValue, 1, 114, 6, 0, // Skip to: 7735
/* 6085 */    MCD::OPC_Decode, 235, 4, 9, // Opcode: SAVEri
/* 6089 */    MCD::OPC_FilterValue, 61, 28, 0, 0, // Skip to: 6122
/* 6094 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6097 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6113
/* 6102 */    MCD::OPC_CheckField, 5, 8, 0, 90, 6, 0, // Skip to: 7735
/* 6109 */    MCD::OPC_Decode, 230, 4, 8, // Opcode: RESTORErr
/* 6113 */    MCD::OPC_FilterValue, 1, 81, 6, 0, // Skip to: 7735
/* 6118 */    MCD::OPC_Decode, 229, 4, 9, // Opcode: RESTOREri
/* 6122 */    MCD::OPC_FilterValue, 62, 28, 0, 0, // Skip to: 6155
/* 6127 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6130 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6146
/* 6135 */    MCD::OPC_CheckField, 5, 8, 0, 57, 6, 0, // Skip to: 7735
/* 6142 */    MCD::OPC_Decode, 220, 5, 8, // Opcode: UMACrr
/* 6146 */    MCD::OPC_FilterValue, 1, 48, 6, 0, // Skip to: 7735
/* 6151 */    MCD::OPC_Decode, 219, 5, 9, // Opcode: UMACri
/* 6155 */    MCD::OPC_FilterValue, 63, 39, 6, 0, // Skip to: 7735
/* 6160 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6163 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6179
/* 6168 */    MCD::OPC_CheckField, 5, 8, 0, 24, 6, 0, // Skip to: 7735
/* 6175 */    MCD::OPC_Decode, 253, 4, 8, // Opcode: SMACrr
/* 6179 */    MCD::OPC_FilterValue, 1, 15, 6, 0, // Skip to: 7735
/* 6184 */    MCD::OPC_Decode, 252, 4, 9, // Opcode: SMACri
/* 6188 */    MCD::OPC_FilterValue, 3, 6, 6, 0, // Skip to: 7735
/* 6193 */    MCD::OPC_ExtractField, 19, 6,  // Inst{24-19} ...
/* 6196 */    MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 6229
/* 6201 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6204 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6220
/* 6209 */    MCD::OPC_CheckField, 5, 8, 0, 239, 5, 0, // Skip to: 7735
/* 6216 */    MCD::OPC_Decode, 182, 4, 68, // Opcode: LDrr
/* 6220 */    MCD::OPC_FilterValue, 1, 230, 5, 0, // Skip to: 7735
/* 6225 */    MCD::OPC_Decode, 181, 4, 69, // Opcode: LDri
/* 6229 */    MCD::OPC_FilterValue, 1, 28, 0, 0, // Skip to: 6262
/* 6234 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6237 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6253
/* 6242 */    MCD::OPC_CheckField, 5, 8, 0, 206, 5, 0, // Skip to: 7735
/* 6249 */    MCD::OPC_Decode, 173, 4, 68, // Opcode: LDUBrr
/* 6253 */    MCD::OPC_FilterValue, 1, 197, 5, 0, // Skip to: 7735
/* 6258 */    MCD::OPC_Decode, 172, 4, 69, // Opcode: LDUBri
/* 6262 */    MCD::OPC_FilterValue, 2, 28, 0, 0, // Skip to: 6295
/* 6267 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6270 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6286
/* 6275 */    MCD::OPC_CheckField, 5, 8, 0, 173, 5, 0, // Skip to: 7735
/* 6282 */    MCD::OPC_Decode, 176, 4, 68, // Opcode: LDUHrr
/* 6286 */    MCD::OPC_FilterValue, 1, 164, 5, 0, // Skip to: 7735
/* 6291 */    MCD::OPC_Decode, 175, 4, 69, // Opcode: LDUHri
/* 6295 */    MCD::OPC_FilterValue, 3, 28, 0, 0, // Skip to: 6328
/* 6300 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6303 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6319
/* 6308 */    MCD::OPC_CheckField, 5, 8, 0, 140, 5, 0, // Skip to: 7735
/* 6315 */    MCD::OPC_Decode, 151, 4, 74, // Opcode: LDDrr
/* 6319 */    MCD::OPC_FilterValue, 1, 131, 5, 0, // Skip to: 7735
/* 6324 */    MCD::OPC_Decode, 150, 4, 75, // Opcode: LDDri
/* 6328 */    MCD::OPC_FilterValue, 4, 28, 0, 0, // Skip to: 6361
/* 6333 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6336 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6352
/* 6341 */    MCD::OPC_CheckField, 5, 8, 0, 107, 5, 0, // Skip to: 7735
/* 6348 */    MCD::OPC_Decode, 175, 5, 76, // Opcode: STrr
/* 6352 */    MCD::OPC_FilterValue, 1, 98, 5, 0, // Skip to: 7735
/* 6357 */    MCD::OPC_Decode, 174, 5, 77, // Opcode: STri
/* 6361 */    MCD::OPC_FilterValue, 5, 28, 0, 0, // Skip to: 6394
/* 6366 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6369 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6385
/* 6374 */    MCD::OPC_CheckField, 5, 8, 0, 74, 5, 0, // Skip to: 7735
/* 6381 */    MCD::OPC_Decode, 142, 5, 76, // Opcode: STBrr
/* 6385 */    MCD::OPC_FilterValue, 1, 65, 5, 0, // Skip to: 7735
/* 6390 */    MCD::OPC_Decode, 141, 5, 77, // Opcode: STBri
/* 6394 */    MCD::OPC_FilterValue, 6, 28, 0, 0, // Skip to: 6427
/* 6399 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6402 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6418
/* 6407 */    MCD::OPC_CheckField, 5, 8, 0, 41, 5, 0, // Skip to: 7735
/* 6414 */    MCD::OPC_Decode, 166, 5, 76, // Opcode: STHrr
/* 6418 */    MCD::OPC_FilterValue, 1, 32, 5, 0, // Skip to: 7735
/* 6423 */    MCD::OPC_Decode, 165, 5, 77, // Opcode: STHri
/* 6427 */    MCD::OPC_FilterValue, 7, 28, 0, 0, // Skip to: 6460
/* 6432 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6435 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6451
/* 6440 */    MCD::OPC_CheckField, 5, 8, 0, 8, 5, 0, // Skip to: 7735
/* 6447 */    MCD::OPC_Decode, 158, 5, 78, // Opcode: STDrr
/* 6451 */    MCD::OPC_FilterValue, 1, 255, 4, 0, // Skip to: 7735
/* 6456 */    MCD::OPC_Decode, 157, 5, 79, // Opcode: STDri
/* 6460 */    MCD::OPC_FilterValue, 8, 28, 0, 0, // Skip to: 6493
/* 6465 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6468 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6484
/* 6473 */    MCD::OPC_CheckField, 5, 8, 0, 231, 4, 0, // Skip to: 7735
/* 6480 */    MCD::OPC_Decode, 170, 4, 80, // Opcode: LDSWrr
/* 6484 */    MCD::OPC_FilterValue, 1, 222, 4, 0, // Skip to: 7735
/* 6489 */    MCD::OPC_Decode, 169, 4, 81, // Opcode: LDSWri
/* 6493 */    MCD::OPC_FilterValue, 9, 28, 0, 0, // Skip to: 6526
/* 6498 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6501 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6517
/* 6506 */    MCD::OPC_CheckField, 5, 8, 0, 198, 4, 0, // Skip to: 7735
/* 6513 */    MCD::OPC_Decode, 162, 4, 68, // Opcode: LDSBrr
/* 6517 */    MCD::OPC_FilterValue, 1, 189, 4, 0, // Skip to: 7735
/* 6522 */    MCD::OPC_Decode, 161, 4, 69, // Opcode: LDSBri
/* 6526 */    MCD::OPC_FilterValue, 10, 28, 0, 0, // Skip to: 6559
/* 6531 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6534 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6550
/* 6539 */    MCD::OPC_CheckField, 5, 8, 0, 165, 4, 0, // Skip to: 7735
/* 6546 */    MCD::OPC_Decode, 165, 4, 68, // Opcode: LDSHrr
/* 6550 */    MCD::OPC_FilterValue, 1, 156, 4, 0, // Skip to: 7735
/* 6555 */    MCD::OPC_Decode, 164, 4, 69, // Opcode: LDSHri
/* 6559 */    MCD::OPC_FilterValue, 11, 28, 0, 0, // Skip to: 6592
/* 6564 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6567 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6583
/* 6572 */    MCD::OPC_CheckField, 5, 8, 0, 132, 4, 0, // Skip to: 7735
/* 6579 */    MCD::OPC_Decode, 180, 4, 80, // Opcode: LDXrr
/* 6583 */    MCD::OPC_FilterValue, 1, 123, 4, 0, // Skip to: 7735
/* 6588 */    MCD::OPC_Decode, 179, 4, 81, // Opcode: LDXri
/* 6592 */    MCD::OPC_FilterValue, 13, 28, 0, 0, // Skip to: 6625
/* 6597 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6600 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6616
/* 6605 */    MCD::OPC_CheckField, 5, 8, 0, 99, 4, 0, // Skip to: 7735
/* 6612 */    MCD::OPC_Decode, 168, 4, 68, // Opcode: LDSTUBrr
/* 6616 */    MCD::OPC_FilterValue, 1, 90, 4, 0, // Skip to: 7735
/* 6621 */    MCD::OPC_Decode, 167, 4, 69, // Opcode: LDSTUBri
/* 6625 */    MCD::OPC_FilterValue, 14, 28, 0, 0, // Skip to: 6658
/* 6630 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6633 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6649
/* 6638 */    MCD::OPC_CheckField, 5, 8, 0, 66, 4, 0, // Skip to: 7735
/* 6645 */    MCD::OPC_Decode, 173, 5, 82, // Opcode: STXrr
/* 6649 */    MCD::OPC_FilterValue, 1, 57, 4, 0, // Skip to: 7735
/* 6654 */    MCD::OPC_Decode, 172, 5, 83, // Opcode: STXri
/* 6658 */    MCD::OPC_FilterValue, 15, 28, 0, 0, // Skip to: 6691
/* 6663 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6666 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6682
/* 6671 */    MCD::OPC_CheckField, 5, 8, 0, 33, 4, 0, // Skip to: 7735
/* 6678 */    MCD::OPC_Decode, 188, 5, 84, // Opcode: SWAPrr
/* 6682 */    MCD::OPC_FilterValue, 1, 24, 4, 0, // Skip to: 7735
/* 6687 */    MCD::OPC_Decode, 187, 5, 85, // Opcode: SWAPri
/* 6691 */    MCD::OPC_FilterValue, 16, 11, 0, 0, // Skip to: 6707
/* 6696 */    MCD::OPC_CheckField, 13, 1, 0, 8, 4, 0, // Skip to: 7735
/* 6703 */    MCD::OPC_Decode, 139, 4, 86, // Opcode: LDArr
/* 6707 */    MCD::OPC_FilterValue, 17, 11, 0, 0, // Skip to: 6723
/* 6712 */    MCD::OPC_CheckField, 13, 1, 0, 248, 3, 0, // Skip to: 7735
/* 6719 */    MCD::OPC_Decode, 171, 4, 86, // Opcode: LDUBArr
/* 6723 */    MCD::OPC_FilterValue, 18, 11, 0, 0, // Skip to: 6739
/* 6728 */    MCD::OPC_CheckField, 13, 1, 0, 232, 3, 0, // Skip to: 7735
/* 6735 */    MCD::OPC_Decode, 174, 4, 86, // Opcode: LDUHArr
/* 6739 */    MCD::OPC_FilterValue, 19, 11, 0, 0, // Skip to: 6755
/* 6744 */    MCD::OPC_CheckField, 13, 1, 0, 216, 3, 0, // Skip to: 7735
/* 6751 */    MCD::OPC_Decode, 144, 4, 87, // Opcode: LDDArr
/* 6755 */    MCD::OPC_FilterValue, 20, 11, 0, 0, // Skip to: 6771
/* 6760 */    MCD::OPC_CheckField, 13, 1, 0, 200, 3, 0, // Skip to: 7735
/* 6767 */    MCD::OPC_Decode, 138, 5, 88, // Opcode: STArr
/* 6771 */    MCD::OPC_FilterValue, 21, 11, 0, 0, // Skip to: 6787
/* 6776 */    MCD::OPC_CheckField, 13, 1, 0, 184, 3, 0, // Skip to: 7735
/* 6783 */    MCD::OPC_Decode, 140, 5, 88, // Opcode: STBArr
/* 6787 */    MCD::OPC_FilterValue, 22, 11, 0, 0, // Skip to: 6803
/* 6792 */    MCD::OPC_CheckField, 13, 1, 0, 168, 3, 0, // Skip to: 7735
/* 6799 */    MCD::OPC_Decode, 164, 5, 88, // Opcode: STHArr
/* 6803 */    MCD::OPC_FilterValue, 23, 11, 0, 0, // Skip to: 6819
/* 6808 */    MCD::OPC_CheckField, 13, 1, 0, 152, 3, 0, // Skip to: 7735
/* 6815 */    MCD::OPC_Decode, 147, 5, 89, // Opcode: STDArr
/* 6819 */    MCD::OPC_FilterValue, 25, 11, 0, 0, // Skip to: 6835
/* 6824 */    MCD::OPC_CheckField, 13, 1, 0, 136, 3, 0, // Skip to: 7735
/* 6831 */    MCD::OPC_Decode, 160, 4, 86, // Opcode: LDSBArr
/* 6835 */    MCD::OPC_FilterValue, 26, 11, 0, 0, // Skip to: 6851
/* 6840 */    MCD::OPC_CheckField, 13, 1, 0, 120, 3, 0, // Skip to: 7735
/* 6847 */    MCD::OPC_Decode, 163, 4, 86, // Opcode: LDSHArr
/* 6851 */    MCD::OPC_FilterValue, 29, 11, 0, 0, // Skip to: 6867
/* 6856 */    MCD::OPC_CheckField, 13, 1, 0, 104, 3, 0, // Skip to: 7735
/* 6863 */    MCD::OPC_Decode, 166, 4, 86, // Opcode: LDSTUBArr
/* 6867 */    MCD::OPC_FilterValue, 31, 11, 0, 0, // Skip to: 6883
/* 6872 */    MCD::OPC_CheckField, 13, 1, 0, 88, 3, 0, // Skip to: 7735
/* 6879 */    MCD::OPC_Decode, 186, 5, 90, // Opcode: SWAPArr
/* 6883 */    MCD::OPC_FilterValue, 32, 28, 0, 0, // Skip to: 6916
/* 6888 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6891 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6907
/* 6896 */    MCD::OPC_CheckField, 5, 8, 0, 64, 3, 0, // Skip to: 7735
/* 6903 */    MCD::OPC_Decode, 156, 4, 91, // Opcode: LDFrr
/* 6907 */    MCD::OPC_FilterValue, 1, 55, 3, 0, // Skip to: 7735
/* 6912 */    MCD::OPC_Decode, 155, 4, 92, // Opcode: LDFri
/* 6916 */    MCD::OPC_FilterValue, 33, 79, 0, 0, // Skip to: 7000
/* 6921 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6924 */    MCD::OPC_FilterValue, 0, 40, 0, 0, // Skip to: 6969
/* 6929 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 6932 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6948
/* 6937 */    MCD::OPC_CheckField, 5, 8, 0, 23, 3, 0, // Skip to: 7735
/* 6944 */    MCD::OPC_Decode, 154, 4, 70, // Opcode: LDFSRrr
/* 6948 */    MCD::OPC_FilterValue, 1, 14, 3, 0, // Skip to: 7735
/* 6953 */    MCD::OPC_CheckPredicate, 0, 9, 3, 0, // Skip to: 7735
/* 6958 */    MCD::OPC_CheckField, 5, 8, 0, 2, 3, 0, // Skip to: 7735
/* 6965 */    MCD::OPC_Decode, 178, 4, 70, // Opcode: LDXFSRrr
/* 6969 */    MCD::OPC_FilterValue, 1, 249, 2, 0, // Skip to: 7735
/* 6974 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 6977 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6986
/* 6982 */    MCD::OPC_Decode, 153, 4, 71, // Opcode: LDFSRri
/* 6986 */    MCD::OPC_FilterValue, 1, 232, 2, 0, // Skip to: 7735
/* 6991 */    MCD::OPC_CheckPredicate, 0, 227, 2, 0, // Skip to: 7735
/* 6996 */    MCD::OPC_Decode, 177, 4, 71, // Opcode: LDXFSRri
/* 7000 */    MCD::OPC_FilterValue, 34, 38, 0, 0, // Skip to: 7043
/* 7005 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7008 */    MCD::OPC_FilterValue, 0, 16, 0, 0, // Skip to: 7029
/* 7013 */    MCD::OPC_CheckPredicate, 0, 205, 2, 0, // Skip to: 7735
/* 7018 */    MCD::OPC_CheckField, 5, 8, 0, 198, 2, 0, // Skip to: 7735
/* 7025 */    MCD::OPC_Decode, 159, 4, 93, // Opcode: LDQFrr
/* 7029 */    MCD::OPC_FilterValue, 1, 189, 2, 0, // Skip to: 7735
/* 7034 */    MCD::OPC_CheckPredicate, 0, 184, 2, 0, // Skip to: 7735
/* 7039 */    MCD::OPC_Decode, 158, 4, 94, // Opcode: LDQFri
/* 7043 */    MCD::OPC_FilterValue, 35, 28, 0, 0, // Skip to: 7076
/* 7048 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7051 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 7067
/* 7056 */    MCD::OPC_CheckField, 5, 8, 0, 160, 2, 0, // Skip to: 7735
/* 7063 */    MCD::OPC_Decode, 149, 4, 95, // Opcode: LDDFrr
/* 7067 */    MCD::OPC_FilterValue, 1, 151, 2, 0, // Skip to: 7735
/* 7072 */    MCD::OPC_Decode, 148, 4, 96, // Opcode: LDDFri
/* 7076 */    MCD::OPC_FilterValue, 36, 28, 0, 0, // Skip to: 7109
/* 7081 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7084 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 7100
/* 7089 */    MCD::OPC_CheckField, 5, 8, 0, 127, 2, 0, // Skip to: 7735
/* 7096 */    MCD::OPC_Decode, 163, 5, 97, // Opcode: STFrr
/* 7100 */    MCD::OPC_FilterValue, 1, 118, 2, 0, // Skip to: 7735
/* 7105 */    MCD::OPC_Decode, 162, 5, 98, // Opcode: STFri
/* 7109 */    MCD::OPC_FilterValue, 37, 79, 0, 0, // Skip to: 7193
/* 7114 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7117 */    MCD::OPC_FilterValue, 0, 40, 0, 0, // Skip to: 7162
/* 7122 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 7125 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 7141
/* 7130 */    MCD::OPC_CheckField, 5, 8, 0, 86, 2, 0, // Skip to: 7735
/* 7137 */    MCD::OPC_Decode, 161, 5, 70, // Opcode: STFSRrr
/* 7141 */    MCD::OPC_FilterValue, 1, 77, 2, 0, // Skip to: 7735
/* 7146 */    MCD::OPC_CheckPredicate, 0, 72, 2, 0, // Skip to: 7735
/* 7151 */    MCD::OPC_CheckField, 5, 8, 0, 65, 2, 0, // Skip to: 7735
/* 7158 */    MCD::OPC_Decode, 171, 5, 70, // Opcode: STXFSRrr
/* 7162 */    MCD::OPC_FilterValue, 1, 56, 2, 0, // Skip to: 7735
/* 7167 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 7170 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7179
/* 7175 */    MCD::OPC_Decode, 160, 5, 71, // Opcode: STFSRri
/* 7179 */    MCD::OPC_FilterValue, 1, 39, 2, 0, // Skip to: 7735
/* 7184 */    MCD::OPC_CheckPredicate, 0, 34, 2, 0, // Skip to: 7735
/* 7189 */    MCD::OPC_Decode, 170, 5, 71, // Opcode: STXFSRri
/* 7193 */    MCD::OPC_FilterValue, 38, 61, 0, 0, // Skip to: 7259
/* 7198 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7201 */    MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 7234
/* 7206 */    MCD::OPC_ExtractField, 5, 8,  // Inst{12-5} ...
/* 7209 */    MCD::OPC_FilterValue, 0, 9, 2, 0, // Skip to: 7735
/* 7214 */    MCD::OPC_CheckField, 25, 5, 0, 4, 0, 0, // Skip to: 7225
/* 7221 */    MCD::OPC_Decode, 154, 5, 70, // Opcode: STDFQrr
/* 7225 */    MCD::OPC_CheckPredicate, 0, 249, 1, 0, // Skip to: 7735
/* 7230 */    MCD::OPC_Decode, 169, 5, 99, // Opcode: STQFrr
/* 7234 */    MCD::OPC_FilterValue, 1, 240, 1, 0, // Skip to: 7735
/* 7239 */    MCD::OPC_CheckField, 25, 5, 0, 4, 0, 0, // Skip to: 7250
/* 7246 */    MCD::OPC_Decode, 153, 5, 71, // Opcode: STDFQri
/* 7250 */    MCD::OPC_CheckPredicate, 0, 224, 1, 0, // Skip to: 7735
/* 7255 */    MCD::OPC_Decode, 168, 5, 100, // Opcode: STQFri
/* 7259 */    MCD::OPC_FilterValue, 39, 28, 0, 0, // Skip to: 7292
/* 7264 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7267 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 7283
/* 7272 */    MCD::OPC_CheckField, 5, 8, 0, 200, 1, 0, // Skip to: 7735
/* 7279 */    MCD::OPC_Decode, 156, 5, 101, // Opcode: STDFrr
/* 7283 */    MCD::OPC_FilterValue, 1, 191, 1, 0, // Skip to: 7735
/* 7288 */    MCD::OPC_Decode, 155, 5, 102, // Opcode: STDFri
/* 7292 */    MCD::OPC_FilterValue, 45, 38, 0, 0, // Skip to: 7335
/* 7297 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7300 */    MCD::OPC_FilterValue, 0, 16, 0, 0, // Skip to: 7321
/* 7305 */    MCD::OPC_CheckPredicate, 0, 169, 1, 0, // Skip to: 7735
/* 7310 */    MCD::OPC_CheckField, 5, 8, 0, 162, 1, 0, // Skip to: 7735
/* 7317 */    MCD::OPC_Decode, 220, 4, 103, // Opcode: PREFETCHr
/* 7321 */    MCD::OPC_FilterValue, 1, 153, 1, 0, // Skip to: 7735
/* 7326 */    MCD::OPC_CheckPredicate, 0, 148, 1, 0, // Skip to: 7735
/* 7331 */    MCD::OPC_Decode, 219, 4, 104, // Opcode: PREFETCHi
/* 7335 */    MCD::OPC_FilterValue, 48, 37, 0, 0, // Skip to: 7377
/* 7340 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7343 */    MCD::OPC_FilterValue, 0, 20, 0, 0, // Skip to: 7368
/* 7348 */    MCD::OPC_CheckField, 5, 8, 0, 4, 0, 0, // Skip to: 7359
/* 7355 */    MCD::OPC_Decode, 143, 4, 105, // Opcode: LDCrr
/* 7359 */    MCD::OPC_CheckPredicate, 0, 115, 1, 0, // Skip to: 7735
/* 7364 */    MCD::OPC_Decode, 152, 4, 106, // Opcode: LDFArr
/* 7368 */    MCD::OPC_FilterValue, 1, 106, 1, 0, // Skip to: 7735
/* 7373 */    MCD::OPC_Decode, 142, 4, 107, // Opcode: LDCri
/* 7377 */    MCD::OPC_FilterValue, 49, 42, 0, 0, // Skip to: 7424
/* 7382 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7385 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 7408
/* 7390 */    MCD::OPC_CheckField, 25, 5, 0, 82, 1, 0, // Skip to: 7735
/* 7397 */    MCD::OPC_CheckField, 5, 8, 0, 75, 1, 0, // Skip to: 7735
/* 7404 */    MCD::OPC_Decode, 141, 4, 70, // Opcode: LDCSRrr
/* 7408 */    MCD::OPC_FilterValue, 1, 66, 1, 0, // Skip to: 7735
/* 7413 */    MCD::OPC_CheckField, 25, 5, 0, 59, 1, 0, // Skip to: 7735
/* 7420 */    MCD::OPC_Decode, 140, 4, 71, // Opcode: LDCSRri
/* 7424 */    MCD::OPC_FilterValue, 50, 16, 0, 0, // Skip to: 7445
/* 7429 */    MCD::OPC_CheckPredicate, 0, 45, 1, 0, // Skip to: 7735
/* 7434 */    MCD::OPC_CheckField, 13, 1, 0, 38, 1, 0, // Skip to: 7735
/* 7441 */    MCD::OPC_Decode, 157, 4, 108, // Opcode: LDQFArr
/* 7445 */    MCD::OPC_FilterValue, 51, 37, 0, 0, // Skip to: 7487
/* 7450 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7453 */    MCD::OPC_FilterValue, 0, 20, 0, 0, // Skip to: 7478
/* 7458 */    MCD::OPC_CheckField, 5, 8, 0, 4, 0, 0, // Skip to: 7469
/* 7465 */    MCD::OPC_Decode, 146, 4, 109, // Opcode: LDDCrr
/* 7469 */    MCD::OPC_CheckPredicate, 0, 5, 1, 0, // Skip to: 7735
/* 7474 */    MCD::OPC_Decode, 147, 4, 110, // Opcode: LDDFArr
/* 7478 */    MCD::OPC_FilterValue, 1, 252, 0, 0, // Skip to: 7735
/* 7483 */    MCD::OPC_Decode, 145, 4, 111, // Opcode: LDDCri
/* 7487 */    MCD::OPC_FilterValue, 52, 37, 0, 0, // Skip to: 7529
/* 7492 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7495 */    MCD::OPC_FilterValue, 0, 20, 0, 0, // Skip to: 7520
/* 7500 */    MCD::OPC_CheckField, 5, 8, 0, 4, 0, 0, // Skip to: 7511
/* 7507 */    MCD::OPC_Decode, 146, 5, 112, // Opcode: STCrr
/* 7511 */    MCD::OPC_CheckPredicate, 0, 219, 0, 0, // Skip to: 7735
/* 7516 */    MCD::OPC_Decode, 159, 5, 113, // Opcode: STFArr
/* 7520 */    MCD::OPC_FilterValue, 1, 210, 0, 0, // Skip to: 7735
/* 7525 */    MCD::OPC_Decode, 145, 5, 114, // Opcode: STCri
/* 7529 */    MCD::OPC_FilterValue, 53, 42, 0, 0, // Skip to: 7576
/* 7534 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7537 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 7560
/* 7542 */    MCD::OPC_CheckField, 25, 5, 0, 186, 0, 0, // Skip to: 7735
/* 7549 */    MCD::OPC_CheckField, 5, 8, 0, 179, 0, 0, // Skip to: 7735
/* 7556 */    MCD::OPC_Decode, 144, 5, 70, // Opcode: STCSRrr
/* 7560 */    MCD::OPC_FilterValue, 1, 170, 0, 0, // Skip to: 7735
/* 7565 */    MCD::OPC_CheckField, 25, 5, 0, 163, 0, 0, // Skip to: 7735
/* 7572 */    MCD::OPC_Decode, 143, 5, 71, // Opcode: STCSRri
/* 7576 */    MCD::OPC_FilterValue, 54, 51, 0, 0, // Skip to: 7632
/* 7581 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7584 */    MCD::OPC_FilterValue, 0, 27, 0, 0, // Skip to: 7616
/* 7589 */    MCD::OPC_CheckField, 25, 5, 0, 11, 0, 0, // Skip to: 7607
/* 7596 */    MCD::OPC_CheckField, 5, 8, 0, 4, 0, 0, // Skip to: 7607
/* 7603 */    MCD::OPC_Decode, 149, 5, 70, // Opcode: STDCQrr
/* 7607 */    MCD::OPC_CheckPredicate, 0, 123, 0, 0, // Skip to: 7735
/* 7612 */    MCD::OPC_Decode, 167, 5, 115, // Opcode: STQFArr
/* 7616 */    MCD::OPC_FilterValue, 1, 114, 0, 0, // Skip to: 7735
/* 7621 */    MCD::OPC_CheckField, 25, 5, 0, 107, 0, 0, // Skip to: 7735
/* 7628 */    MCD::OPC_Decode, 148, 5, 71, // Opcode: STDCQri
/* 7632 */    MCD::OPC_FilterValue, 55, 37, 0, 0, // Skip to: 7674
/* 7637 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7640 */    MCD::OPC_FilterValue, 0, 20, 0, 0, // Skip to: 7665
/* 7645 */    MCD::OPC_CheckField, 5, 8, 0, 4, 0, 0, // Skip to: 7656
/* 7652 */    MCD::OPC_Decode, 151, 5, 116, // Opcode: STDCrr
/* 7656 */    MCD::OPC_CheckPredicate, 0, 74, 0, 0, // Skip to: 7735
/* 7661 */    MCD::OPC_Decode, 152, 5, 117, // Opcode: STDFArr
/* 7665 */    MCD::OPC_FilterValue, 1, 65, 0, 0, // Skip to: 7735
/* 7670 */    MCD::OPC_Decode, 150, 5, 118, // Opcode: STDCri
/* 7674 */    MCD::OPC_FilterValue, 60, 39, 0, 0, // Skip to: 7718
/* 7679 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7682 */    MCD::OPC_FilterValue, 0, 48, 0, 0, // Skip to: 7735
/* 7687 */    MCD::OPC_ExtractField, 5, 8,  // Inst{12-5} ...
/* 7690 */    MCD::OPC_FilterValue, 10, 4, 0, 0, // Skip to: 7699
/* 7695 */    MCD::OPC_Decode, 213, 2, 119, // Opcode: CASAasi10
/* 7699 */    MCD::OPC_FilterValue, 128, 1, 9, 0, 0, // Skip to: 7714
/* 7705 */    MCD::OPC_CheckPredicate, 0, 4, 0, 0, // Skip to: 7714
/* 7710 */    MCD::OPC_Decode, 216, 2, 119, // Opcode: CASrr
/* 7714 */    MCD::OPC_Decode, 214, 2, 120, // Opcode: CASArr
/* 7718 */    MCD::OPC_FilterValue, 62, 12, 0, 0, // Skip to: 7735
/* 7723 */    MCD::OPC_CheckField, 5, 9, 128, 1, 4, 0, 0, // Skip to: 7735
/* 7731 */    MCD::OPC_Decode, 215, 2, 121, // Opcode: CASXrr
/* 7735 */    MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableSparcV832[] = {
/* 0 */       MCD::OPC_ExtractField, 8, 6,  // Inst{13-8} ...
/* 3 */       MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 33
/* 8 */       MCD::OPC_CheckField, 29, 3, 4, 41, 0, 0, // Skip to: 56
/* 15 */      MCD::OPC_CheckField, 19, 6, 58, 34, 0, 0, // Skip to: 56
/* 22 */      MCD::OPC_CheckField, 5, 3, 0, 27, 0, 0, // Skip to: 56
/* 29 */      MCD::OPC_Decode, 206, 5, 72, // Opcode: TRAPrr
/* 33 */      MCD::OPC_FilterValue, 32, 18, 0, 0, // Skip to: 56
/* 38 */      MCD::OPC_CheckField, 29, 3, 4, 11, 0, 0, // Skip to: 56
/* 45 */      MCD::OPC_CheckField, 19, 6, 58, 4, 0, 0, // Skip to: 56
/* 52 */      MCD::OPC_Decode, 205, 5, 73, // Opcode: TRAPri
/* 56 */      MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableSparcV932[] = {
/* 0 */       MCD::OPC_ExtractField, 8, 6,  // Inst{13-8} ...
/* 3 */       MCD::OPC_FilterValue, 0, 30, 0, 0, // Skip to: 38
/* 8 */       MCD::OPC_CheckPredicate, 0, 53, 0, 0, // Skip to: 66
/* 13 */      MCD::OPC_CheckField, 29, 3, 4, 46, 0, 0, // Skip to: 66
/* 20 */      MCD::OPC_CheckField, 19, 6, 58, 39, 0, 0, // Skip to: 66
/* 27 */      MCD::OPC_CheckField, 5, 3, 0, 32, 0, 0, // Skip to: 66
/* 34 */      MCD::OPC_Decode, 199, 5, 72, // Opcode: TICCrr
/* 38 */      MCD::OPC_FilterValue, 32, 23, 0, 0, // Skip to: 66
/* 43 */      MCD::OPC_CheckPredicate, 0, 18, 0, 0, // Skip to: 66
/* 48 */      MCD::OPC_CheckField, 29, 3, 4, 11, 0, 0, // Skip to: 66
/* 55 */      MCD::OPC_CheckField, 19, 6, 58, 4, 0, 0, // Skip to: 66
/* 62 */      MCD::OPC_Decode, 198, 5, 73, // Opcode: TICCri
/* 66 */      MCD::OPC_Fail,
  0
};

static bool checkDecoderPredicate(unsigned Idx, const FeatureBitset &Bits) {
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    return (Bits[Sparc::FeatureV9]);
  case 1:
    return (Bits[Sparc::FeaturePWRPSR]);
  case 2:
    return (Bits[Sparc::FeatureVIS3]);
  case 3:
    return (Bits[Sparc::FeatureVIS]);
  case 4:
    return (Bits[Sparc::FeatureVIS2]);
  }
}

template <typename InsnType>
static DecodeStatus decodeToMCInst(DecodeStatus S, unsigned Idx, InsnType insn, MCInst &MI,
                                   uint64_t Address, const MCDisassembler *Decoder, bool &DecodeComplete) {
  DecodeComplete = true;
  using TmpType = std::conditional_t<std::is_integral<InsnType>::value, InsnType, uint64_t>;
  TmpType tmp;
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    tmp = fieldFromInstruction(insn, 0, 22);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 1:
    tmp = fieldFromInstruction(insn, 0, 19);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 2:
    tmp = fieldFromInstruction(insn, 0, 22);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 3:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 14), 0, 14);
    insertBits(tmp, fieldFromInstruction(insn, 20, 2), 14, 2);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 4:
    return S;
  case 5:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 22);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 6:
    tmp = fieldFromInstruction(insn, 0, 19);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 20, 2);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 7:
    tmp = fieldFromInstruction(insn, 0, 30);
    if (!Check(S, DecodeCall(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 8:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 9:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 10:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 11:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 12:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 13:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 14:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 15:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 6);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 16:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 6);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 17:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 18:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeASRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 19:
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 20:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 21:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 22:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 2);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 23:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 11);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 24:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 2);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 11);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 25:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 26:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 27:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 10);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 28:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeASRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 29:
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 30:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeASRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 31:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodePRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 32:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodePRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 33:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 34:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 35:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 36:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 37:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 38:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 39:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 40:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 41:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 42:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 43:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 44:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 45:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 46:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 47:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 48:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 2);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 49:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 50:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 2);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 51:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 52:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 2);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 53:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 54:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 55:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 56:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 57:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 58:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 59:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 60:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 61:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 62:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 63:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 64:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 65:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 66:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 67:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 68:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 69:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 70:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 71:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 72:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 73:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 74:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 75:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 76:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 77:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 78:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 79:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 80:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 81:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 82:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 83:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 84:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 85:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 86:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 87:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 88:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 89:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 90:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 91:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 92:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 93:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 94:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 95:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 96:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 97:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 98:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 99:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 100:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 101:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 102:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 103:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 104:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 105:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 106:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 107:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 108:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 109:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 110:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 111:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 112:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 113:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 114:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 115:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 116:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 117:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 118:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 119:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 120:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 121:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  }
}

template <typename InsnType>
static DecodeStatus decodeInstruction(const uint8_t DecodeTable[], MCInst &MI,
                                      InsnType insn, uint64_t Address,
                                      const MCDisassembler *DisAsm,
                                      const MCSubtargetInfo &STI) {
  const FeatureBitset &Bits = STI.getFeatureBits();

  const uint8_t *Ptr = DecodeTable;
  uint64_t CurFieldValue = 0;
  DecodeStatus S = MCDisassembler::Success;
  while (true) {
    ptrdiff_t Loc = Ptr - DecodeTable;
    switch (*Ptr) {
    default:
      errs() << Loc << ": Unexpected decode table opcode!\n";
      return MCDisassembler::Fail;
    case MCD::OPC_ExtractField: {
      unsigned Start = *++Ptr;
      unsigned Len = *++Ptr;
      ++Ptr;
      CurFieldValue = fieldFromInstruction(insn, Start, Len);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_ExtractField(" << Start << ", "
                   << Len << "): " << CurFieldValue << "\n");
      break;
    }
    case MCD::OPC_FilterValue: {
      // Decode the field value.
      unsigned Len;
      uint64_t Val = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // Perform the filter operation.
      if (Val != CurFieldValue)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_FilterValue(" << Val << ", " << NumToSkip
                   << "): " << ((Val != CurFieldValue) ? "FAIL:" : "PASS:")
                   << " continuing at " << (Ptr - DecodeTable) << "\n");

      break;
    }
    case MCD::OPC_CheckField: {
      unsigned Start = *++Ptr;
      unsigned Len = *++Ptr;
      uint64_t FieldValue = fieldFromInstruction(insn, Start, Len);
      // Decode the field value.
      unsigned PtrLen = 0;
      uint64_t ExpectedValue = decodeULEB128(++Ptr, &PtrLen);
      Ptr += PtrLen;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // If the actual and expected values don't match, skip.
      if (ExpectedValue != FieldValue)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckField(" << Start << ", "
                   << Len << ", " << ExpectedValue << ", " << NumToSkip
                   << "): FieldValue = " << FieldValue << ", ExpectedValue = "
                   << ExpectedValue << ": "
                   << ((ExpectedValue == FieldValue) ? "PASS\n" : "FAIL\n"));
      break;
    }
    case MCD::OPC_CheckPredicate: {
      unsigned Len;
      // Decode the Predicate Index value.
      unsigned PIdx = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;
      // Check the predicate.
      bool Pred;
      if (!(Pred = checkDecoderPredicate(PIdx, Bits)))
        Ptr += NumToSkip;
      (void)Pred;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckPredicate(" << PIdx << "): "
            << (Pred ? "PASS\n" : "FAIL\n"));

      break;
    }
    case MCD::OPC_Decode: {
      unsigned Len;
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      unsigned DecodeIdx = decodeULEB128(Ptr, &Len);
      Ptr += Len;

      MI.clear();
      MI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, MI, Address, DisAsm, DecodeComplete);
      assert(DecodeComplete);

      LLVM_DEBUG(dbgs() << Loc << ": OPC_Decode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": "
                   << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
      return S;
    }
    case MCD::OPC_TryDecode: {
      unsigned Len;
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      unsigned DecodeIdx = decodeULEB128(Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // Perform the decode operation.
      MCInst TmpMI;
      TmpMI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, TmpMI, Address, DisAsm, DecodeComplete);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_TryDecode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": ");

      if (DecodeComplete) {
        // Decoding complete.
        LLVM_DEBUG(dbgs() << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
        MI = TmpMI;
        return S;
      } else {
        assert(S == MCDisassembler::Fail);
        // If the decoding was incomplete, skip.
        Ptr += NumToSkip;
        LLVM_DEBUG(dbgs() << "FAIL: continuing at " << (Ptr - DecodeTable) << "\n");
        // Reset decode status. This also drops a SoftFail status that could be
        // set before the decode attempt.
        S = MCDisassembler::Success;
      }
      break;
    }
    case MCD::OPC_SoftFail: {
      // Decode the mask values.
      unsigned Len;
      uint64_t PositiveMask = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      uint64_t NegativeMask = decodeULEB128(Ptr, &Len);
      Ptr += Len;
      bool Fail = (insn & PositiveMask) != 0 || (~insn & NegativeMask) != 0;
      if (Fail)
        S = MCDisassembler::SoftFail;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_SoftFail: " << (Fail ? "FAIL\n" : "PASS\n"));
      break;
    }
    case MCD::OPC_Fail: {
      LLVM_DEBUG(dbgs() << Loc << ": OPC_Fail\n");
      return MCDisassembler::Fail;
    }
    }
  }
  llvm_unreachable("bogosity detected in disassembler state machine!");
}


} // end namespace llvm
